% MACHINE Doors

:- dec_p_type(doors_inv1(sp,rpb)).
doors_inv1(PositionsDG,Door_open_p) :-
  pfun(Door_open_p) &
  dompf(Door_open_p,PositionsDG).

:- dec_p_type(doors_inv2(sp,rpb,rpb,rpb)).
doors_inv2(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) :-
  exists(Po in PositionsDG,
    dec(Po,pos) &
    applyTo(Gear_ext_p,Po,false) &
    applyTo(Gear_ret_p,Po,false)
  )
    implies
      Door_open_p = cp(PositionsDG,{true}).

:- dec_p_type(doors_init(sp,rpb,rpb,rpb)).
doors_init(PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p) :-
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{false}) &
  Door_open_p = cp(PositionsDG,{false}).

:- dec_p_type(doors_start_GearExtend(sp,rpb,rpb,rpb)).
doors_start_GearExtend(PositionsDG,Gear_ret_p,Door_open_p,Gear_ret_p_) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ret_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  foplus(Gear_ret_p,Po,false,Gear_ret_p_).

:- dec_p_type(doors_make_GearExtended(sp,rpb,rpb,rpb)).
doors_make_GearExtended(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_ext_p_) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  foplus(Gear_ext_p,Po,true,Gear_ext_p_).

:- dec_p_type(doors_start_GearRetract(sp,rpb,rpb,rpb)).
doors_start_GearRetract(PositionsDG,Gear_ext_p,Door_open_p,Gear_ext_p_) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,true) &
  Door_open_p = cp(PositionsDG,{true}) &
  applyTo(Gear_ext_p_,Po,false).

:- dec_p_type(doors_make_GearRetracted(sp,rpb,rpb,rpb)).
doors_make_GearRetracted(PositionsDG,Gear_ext_p,Gear_ret_p,Gear_ret_p_) :-
  dec(Po,pos) &
  Po in PositionsDG &
  applyTo(Gear_ext_p,Po,false) &
  applyTo(Gear_ret_p,Po,false) &
  foplus(Gear_ret_p,Po,true,Gear_ret_p_).

:- dec_p_type(doors_make_DoorOpen(rpb,rpb)).
doors_make_DoorOpen(Door_open_p,Door_open_p_) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,false) &
  foplus(Door_open_p,Po,true,Door_open_p_).

:- dec_p_type(doors_start_DoorClosing(sp,rpb,rpb,rpb,rpb)).
doors_start_DoorClosing(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_open_p_
    ) :-
  dec(Po,pos) &
  applyTo(Door_open_p,Po,true) &
  Gear_ext_p = cp(PositionsDG,{true}) &
  Gear_ret_p = cp(PositionsDG,{true}) &
  foplus(Door_open_p,Po,false,Door_open_p_).


