% Proof obligations of 

% MACHINE DoorsIntermediate

% Run check_doorsIntermediate

:- dec_p_type(doorsIntermediate_inv2_wd).
doorsIntermediate_inv2_wd :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p],rpb) &
  dec(Po,pos) &
  doors_inv1(PositionsDG,Door_open_p) &
  doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
  neg(Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_open_p,{}) &
          pfun(Door_open_p) &
          (applyTo(Door_open_p,Po,true)
             implies
               ncomp({[Po,Po]},Door_closed_p,{}) &
               pfun(Door_closed_p)
          )
  ).

:- dec_p_type(doorsIntermediate_init_inv1).
doorsIntermediate_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p],rpb) &
  doorsIntermediate_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p
    ) &
  doorsIntermediate_inv1(PositionsDG,Door_closed_p).

:- dec_p_type(doorsIntermediate_init_inv2).
doorsIntermediate_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p],rpb) &
  doorsIntermediate_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p
    ) &
  doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p).

:- dec_p_type(doorsIntermediate_start_DoorOpening_grd1).
doorsIntermediate_start_DoorOpening_grd1 :-
  dec(PositionsDG,sp) &
  dec(Door_closed_p,rpb) &
  dec(Po,pos) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_closed_p,{}) &
          pfun(Door_closed_p)
  ).

:- dec_p_type(n_doorsIntermediate_inv1(sp,rpb)).
n_doorsIntermediate_inv1(PositionsDG,Door_closed_p) :-
  neg(pfun(Door_closed_p) &
      dompf(Door_closed_p,PositionsDG)
  ).

:- dec_p_type(doorsIntermediate_start_doorOpening_inv1).
doorsIntermediate_start_doorOpening_inv1 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_closed_p_],rpb) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      doorsIntermediate_start_DoorOpening(Door_closed_p,Door_closed_p_)
        implies
          doorsIntermediate_inv1(PositionsDG,Door_closed_p_)
  ).

:- dec_p_type(n_doorsIntermediate_inv2(sp,rpb,rpb)).
n_doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) :-
  neg(foreach(Po in PositionsDG,[M1,M2],
        dec(Po,pos) & dec([M1,M2],bool) &
        neg(M1 = true & M2 = true),
        applyTo(Door_open_p,Po,M1) &
        applyTo(Door_closed_p,Po,M2)
      )
  ).

:- dec_p_type(doorsIntermediate_start_doorOpening_inv2).
doorsIntermediate_start_doorOpening_inv2 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_closed_p_],rpb) &
  neg(doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) &
      doorsIntermediate_start_DoorOpening(Door_closed_p,Door_closed_p_)
        implies
          doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p_)
  ).

:- dec_p_type(doorsIntermediate_make_DoorOpen_grd2).
doorsIntermediate_make_DoorOpen_grd2 :-
  dec(PositionsDG,sp) &
  dec(Door_closed_p,rpb) &
  dec(Po,pos) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_closed_p,{}) &
          pfun(Door_closed_p)
  ).

:- dec_p_type(doorsIntermediate_make_DoorOpen_inv2).
doorsIntermediate_make_DoorOpen_inv2 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_open_p,Door_open_p_],rpb) &
  neg(doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) &
      doorsIntermediate_make_DoorOpen(
        Door_open_p,
        Door_closed_p,
        Door_open_p_
      )
        implies
          doorsIntermediate_inv2(PositionsDG,Door_open_p_,Door_closed_p)
  ).

:- dec_p_type(doorsIntermediate_start_DoorClosing_inv2).
doorsIntermediate_start_DoorClosing_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_closed_p,Door_open_p,Door_open_p_],rpb) &
  neg(doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) &
      doorsIntermediate_start_DoorClosing(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Door_open_p,
        Door_open_p_
      )
        implies
          doorsIntermediate_inv2(PositionsDG,Door_open_p_,Door_closed_p)
  ).

:- dec_p_type(doorsIntermediate_make_DoorClosed_grd1).
doorsIntermediate_make_DoorClosed_grd1 :-
  dec(PositionsDG,sp) &
  dec(Door_closed_p,rpb) &
  dec(Po,pos) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_closed_p,{}) &
          pfun(Door_closed_p)
  ).

:- dec_p_type(doorsIntermediate_make_DoorClosed_grd2).
doorsIntermediate_make_DoorClosed_grd2 :-
  dec(PositionsDG,sp) &
  dec(Door_open_p,rpb) &
  dec(Po,pos) &
  neg(doors_inv1(PositionsDG,Door_open_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Door_open_p,{}) &
          pfun(Door_open_p)
  ).

:- dec_p_type(doorsIntermediate_make_DoorClosed_inv1).
doorsIntermediate_make_DoorClosed_inv1 :-
  dec(PositionsDG,sp) &
  dec([Door_open_p,Door_closed_p,Door_closed_p_],rpb) &
  neg(doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
      doorsIntermediate_make_DoorClosed(
        Door_open_p,
        Door_closed_p,
        Door_closed_p_
      )
        implies
          doorsIntermediate_inv1(PositionsDG,Door_closed_p_)
  ).

:- dec_p_type(doorsIntermediate_make_DoorClosed_inv2).
doorsIntermediate_make_DoorClosed_inv2 :-
  dec(PositionsDG,sp) &
  dec([Door_closed_p,Door_open_p,Door_closed_p_,Door_open_p_],rpb) &
  neg(doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p) &
      doorsIntermediate_make_DoorClosed(
        Door_open_p,
        Door_closed_p,
        Door_closed_p_
       )
         implies
           doorsIntermediate_inv2(PositionsDG,Door_open_p,Door_closed_p_)
  ).

% consult('lgs.pl') & lDoorsIntermediatePO.
:- dec_p_type(check_doorsIntermediate).
check_doorsIntermediate :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking doorsIntermediate_inv2_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_inv2_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     doorsIntermediate_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     doorsIntermediate_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_start_DoorOpening_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_start_DoorOpening_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_start_doorOpening_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_start_doorOpening_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_start_doorOpening_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_start_doorOpening_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorOpen_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorOpen_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorOpen_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorOpen_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_start_DoorClosing_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_start_DoorClosing_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorClosed_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorClosed_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorClosed_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorClosed_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorClosed_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorClosed_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking doorsIntermediate_make_DoorClosed_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(doorsIntermediate_make_DoorClosed_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 13) discharged in ') &
     write(T) & write(' seconds') & nl
  ).


