% Proof obligations of 

% MACHINE Failures

% Run check_failures

:- dec_p_type(failures_init_inv2).
failures_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv2(
    General_EV_fail,
    Open_EV_fail,
    Close_EV_fail,
    Extend_EV_fail,
    Retract_EV_fail
  ).

:- dec_p_type(failures_init_inv3).
failures_init_inv3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail).

:- dec_p_type(failures_init_inv5).
failures_init_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv5(NextInputReadForOpenSwitch).

:- dec_p_type(failures_init_inv6).
failures_init_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv6(NextInputReadForClosedSwitch).

:- dec_p_type(failures_init_inv7).
failures_init_inv7 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv7(NextInputReadForPressurizedcircuit).

:- dec_p_type(failures_init_inv8).
failures_init_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv8(NextInputReadForDoorOpeningClosing).

:- dec_p_type(failures_init_inv9).
failures_init_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv9(NextInputReadForGearStartExtendingRetracting).

:- dec_p_type(failures_init_inv10).
failures_init_inv10 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv10(NextInputReadForGearEndExtendingRetracting).

:- dec_p_type(failures_init_inv11).
failures_init_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind,Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle,
       Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
       Extend_EV_fail,Retract_EV_fail,Anomaly],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv,NextInputReadForOpenSwitch,
       NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForDoorOpeningClosing,
       NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,Unchanged20s],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  failures_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv,
    Analogical_switch_fail,General_EV_fail,Open_EV_fail,Close_EV_fail,
    Extend_EV_fail,Retract_EV_fail,Door_cylinder_fail,Gear_cylinder_fail,
    Anomaly,NextInputReadForOpenSwitch,
    NextInputReadForClosedSwitch,NextInputReadForPressurizedcircuit,
    NextInputReadForDoorOpeningClosing,
    NextInputReadForGearStartExtendingRetracting,
    NextInputReadForGearEndExtendingRetracting,Unchanged20s
  ) &
  failures_inv11(Unchanged20s).

:- dec_p_type(n_failures_inv5(int)).
n_failures_inv5(NextInputReadForOpenSwitch) :-
  neg(0 =< NextInputReadForOpenSwitch).

:- dec_p_type(failures_ReadHandleSwitchCircuit_inv5).
failures_ReadHandleSwitchCircuit_inv5 :-
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv5(NextInputReadForOpenSwitch) &
    failures_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_
    )
    implies
      failures_inv5(NextInputReadForOpenSwitch_)
  ).

:- dec_p_type(n_failures_inv6(int)).
n_failures_inv6(NextInputReadForClosedSwitch) :-
  neg(0 =< NextInputReadForClosedSwitch).

:- dec_p_type(failures_ReadHandleSwitchCircuit_inv6).
failures_ReadHandleSwitchCircuit_inv6 :-
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    failures_inv6(NextInputReadForClosedSwitch) &
    failures_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_
    )
    implies
      failures_inv6(NextInputReadForClosedSwitch_)
  ).

:- dec_p_type(n_failures_inv11(int)).
n_failures_inv11(Unchanged20s) :-
  neg(0 =< Unchanged20s).

:- dec_p_type(failures_ReadHandleSwitchCircuit_inv11).
failures_ReadHandleSwitchCircuit_inv11 :-
  dec(PositionsHandle,sph) &
  dec(PositionsSwitch,sps) &
  dec([General_EV,Circuit_pressurized_ind,Anomaly,Circuit_pressurized_ind_,
       End_cycle_,Anomaly_],bool) &
  dec([Handle_ind,Handle_ind_],posh) &
  dec([CurrentTime,NextInputReadForOpenSwitch,NextInputReadForPressurizedcircuit,
       NextInputReadForClosedSwitch,Unchanged20s,
       NextInputReadForOpenSwitch_,Unchanged20s_,
       NextInputReadForClosedSwitch_],int) &
  dec(Analogical_switch_ind_,poss) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv11(Unchanged20s) &
    failures_ReadHandleSwitchCircuit(
      PositionsHandle,
      PositionsSwitch,
      General_EV,
      Handle_ind,
      Circuit_pressurized_ind,
      CurrentTime,
      Anomaly,
      NextInputReadForOpenSwitch,
      NextInputReadForPressurizedcircuit,
      NextInputReadForClosedSwitch,
      Unchanged20s,
      Handle_ind_,
      Analogical_switch_ind_,
      Circuit_pressurized_ind_,
      End_cycle_,
      NextInputReadForOpenSwitch_,
      Anomaly_,
      Unchanged20s_,
      NextInputReadForClosedSwitch_
    )
    implies
      failures_inv11(Unchanged20s_)
  ).

:- dec_p_type(failures_ReadHandleSwitchCircuit_act5).
failures_ReadHandleSwitchCircuit_act5 :-
  dec(B1,bool) &
  dec([Handle_ind,Handle_sensor_value],posh) &
  dec([M1,CurrentTime,NextInputReadForOpenSwitch],int) &
  neg(
    bool(B1,Handle_ind neq Handle_sensor_value) &
    M1 is CurrentTime + 10
      implies
        ncomp({[B1,B1]},{[false,NextInputReadForOpenSwitch],[true,M1]},{}) &
        pfun({[false,NextInputReadForOpenSwitch],[true,M1]})
  ).

:- dec_p_type(failures_ReadHandleSwitchCircuit_act7).
failures_ReadHandleSwitchCircuit_act7 :-
  dec(B2,bool) &
  dec([Handle_ind,Handle_sensor_value],posh) &
  dec([M2,CurrentTime,Unchanged20s],int) &
  neg(
    bool(B2,Handle_sensor_value neq Handle_ind) &
    M2 is CurrentTime + 20
      implies
        ncomp({[B2,B2]},{[true,M2],[false,Unchanged20s]},{}) &
        pfun({[true,M2],[false,Unchanged20s]})
  ).

:- dec_p_type(failures_ReadHandleSwitchCircuit_act8).
failures_ReadHandleSwitchCircuit_act8 :-
  dec(B3,bool) &
  dec([CurrentTime,Unchanged20s],int) &
  neg(
    bool(B3,CurrentTime = Unchanged20s)
      implies
        ncomp({[B3,B3]},{[true,15],[false,0]},{}) &
        pfun({[true,15],[false,0]})
  ).

:- dec_p_type(n_failures_inv9(int)).
n_failures_inv9(NextInputReadForGearStartExtendingRetracting) :-
  neg(0 =< NextInputReadForGearStartExtendingRetracting).

:- dec_p_type(failures_ReadGearsShock_inv9).
failures_ReadGearsShock_inv9 :-
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    failures_inv9(NextInputReadForGearStartExtendingRetracting) &
    failures_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv9(NextInputReadForGearStartExtendingRetracting_)
  ).

:- dec_p_type(n_failures_inv10(int)).
n_failures_inv10(NextInputReadForGearEndExtendingRetracting) :-
  neg(0 =< NextInputReadForGearEndExtendingRetracting).

:- dec_p_type(failures_ReadGearsShock_inv10).
failures_ReadGearsShock_inv10 :-
  dec([Gear_extended_ind,Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_shock_absorber_p,Gear_extended_ind_,Gear_retracted_ind_,
       Gear_shock_absorber_ind_],rpb) &
  dec([Gears_locked_down_,Gears_maneuvering_,Extend_EV,Retract_EV,Anomaly,
       End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       NextInputReadForGearEndExtendingRetracting,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  neg(
    failures_inv10(NextInputReadForGearEndExtendingRetracting) &
    failures_ReadGearsShock(
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Gear_shock_absorber_p,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForGearStartExtendingRetracting,
      NextInputReadForGearEndExtendingRetracting,
      Gear_extended_ind_,
      Gear_retracted_ind_,
      Gear_shock_absorber_ind_,
      Gears_locked_down_,
      Gears_maneuvering_,
      End_cycle_,
      Anomaly_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv10(NextInputReadForGearEndExtendingRetracting_)
  ).

:- dec_p_type(failures_ReadGearsShock_act8).
failures_ReadGearsShock_act8 :-
  dec(B1,bool) &
  dec([CurrentTime,NextInputReadForGearEndExtendingRetracting],int) &
  neg(
    bool(B1,CurrentTime = NextInputReadForGearEndExtendingRetracting)
      implies
        ncomp(
          {[B1,B1]},
          {[true,0],[false,NextInputReadForGearEndExtendingRetracting]},
          {}
        ) &
        pfun({[true,0],[false,NextInputReadForGearEndExtendingRetracting]})
      ).

:- dec_p_type(failures_ReadGearsShock_act9).
failures_ReadGearsShock_act9 :-
  dec(B2,bool) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting],int) &
  neg(
    bool(B2,CurrentTime = NextInputReadForGearStartExtendingRetracting)
      implies
        ncomp(
          {[B2,B2]},
          {[true,0],[false,NextInputReadForGearStartExtendingRetracting]},
          {}
        ) &
        pfun({[true,0],[false,NextInputReadForGearStartExtendingRetracting]})
      ).

:- dec_p_type(n_failures_inv8(int)).
n_failures_inv8(NextInputReadForDoorOpeningClosing) :-
  neg(0 =< NextInputReadForDoorOpeningClosing).

:- dec_p_type(failures_ReadDoors_inv8).
failures_ReadDoors_inv8 :-
  dec([Door_open_p,Door_closed_p,Door_open_ind_,Door_closed_ind_],rpb) &
  dec([Open_EV,Close_EV,Anomaly,End_cycle_,Anomaly_],bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,
       NextInputReadForDoorOpeningClosing_],int) &
  neg(
    failures_inv8(NextInputReadForDoorOpeningClosing) &
    failures_ReadDoors(
      Door_open_p,
      Door_closed_p,
      Open_EV,
      Close_EV,
      CurrentTime,
      Anomaly,
      NextInputReadForDoorOpeningClosing,
      Door_open_ind_,
      Door_closed_ind_,
      End_cycle_,
      Anomaly_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        failures_inv8(NextInputReadForDoorOpeningClosing_)
  ).

:- dec_p_type(failures_ReadDoors_act5).
failures_ReadDoors_act5 :-
  dec(B1,bool) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing],int) &
  neg(
    bool(B1,CurrentTime = NextInputReadForDoorOpeningClosing)
      implies
        ncomp(
          {[B1,B1]},
          {[true,0],[false,NextInputReadForDoorOpeningClosing]},
          {}
        ) &
        pfun({[true,0],[false,NextInputReadForDoorOpeningClosing]})
      ).

:- dec_p_type(n_failures_inv7(int)).
n_failures_inv7(NextInputReadForPressurizedcircuit) :-
  neg(0 =< NextInputReadForPressurizedcircuit).

:- dec_p_type(failures_OutputGEV_inv7).
failures_OutputGEV_inv7 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_,
       NextInputReadForPressurizedcircuit,
       NextInputReadForPressurizedcircuit_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_],bool) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv7(NextInputReadForPressurizedcircuit) &
    failures_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_,
      NextInputReadForPressurizedcircuit_
    )
      implies
        failures_inv7(NextInputReadForPressurizedcircuit_)
  ).

:- dec_p_type(failures_OutputGEV_act5).
failures_OutputGEV_act5 :-
  dec([General_EV,General_EV_value],bool) &
  dec([M4,M5,CurrentTime],int) &
  neg(
    General_EV_value neq General_EV &
    M4 is CurrentTime + 20 &
    M5 is CurrentTime + 100
      implies
        ncomp(
          {[[General_EV,General_EV_value],[General_EV,General_EV_value]]},
          {[[false,true],M4],[[true,false],M5]},
          {}
        ) &
        pfun({[[false,true],M4],[[true,false],M5]})
      ).

:- dec_p_type(failures_OutputOpenEV_inv8).
failures_OutputOpenEV_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForDoorOpeningClosing,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv8(NextInputReadForDoorOpeningClosing) &
    failures_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        failures_inv8(NextInputReadForDoorOpeningClosing_)
  ).

:- dec_p_type(failures_OutputCloseEv_inv8).
failures_OutputCloseEv_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,NextInputReadForDoorOpeningClosing,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv8(NextInputReadForDoorOpeningClosing) &
    failures_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_,
      NextInputReadForDoorOpeningClosing_
    )
      implies
        failures_inv8(NextInputReadForDoorOpeningClosing_)
  ).

:- dec_p_type(failures_OutputExtendEV_inv9).
failures_OutputExtendEV_inv9 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv9(NextInputReadForGearStartExtendingRetracting) &
    failures_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv9(NextInputReadForGearStartExtendingRetracting_)
  ).

:- dec_p_type(failures_OutputExtendEV_inv10).
failures_OutputExtendEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearEndExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv10(NextInputReadForGearEndExtendingRetracting) &
    failures_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv10(NextInputReadForGearEndExtendingRetracting_)
  ).

:- dec_p_type(failures_OutputRetractEV_inv9).
failures_OutputRetractEV_inv9 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearStartExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv9(NextInputReadForGearStartExtendingRetracting) &
    failures_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv9(NextInputReadForGearStartExtendingRetracting_)
  ).

:- dec_p_type(failures_OutputRetractEV_inv10).
failures_OutputRetractEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,NextInputReadForGearEndExtendingRetracting,
       AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,
       NextInputReadForGearStartExtendingRetracting_,
       NextInputReadForGearEndExtendingRetracting_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    failures_inv10(NextInputReadForGearEndExtendingRetracting) &
    failures_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_,
      NextInputReadForGearStartExtendingRetracting_,
      NextInputReadForGearEndExtendingRetracting_
    )
      implies
        failures_inv10(NextInputReadForGearEndExtendingRetracting_)
  ).

:- dec_p_type(n_failures_inv2(bool,bool,bool,bool,bool)).
n_failures_inv2(
    General_EV_fail,
    Open_EV_fail,
    Close_EV_fail,
    Extend_EV_fail,
    Retract_EV_fail
  ) :-
  neg(
    General_EV_fail in {false,true} &
    Open_EV_fail in {false,true} &
    Close_EV_fail in {false,true} &
    Extend_EV_fail in {false,true} &
    Retract_EV_fail in {false,true}
  ).

:- dec_p_type(failures_MakeGeneralEVFail_inv2).
failures_MakeGeneralEVFail_inv2 :-
  dec([General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,
       Retract_EV_fail,General_EV_fail_],bool) &
  neg(
    failures_inv2(
      General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,Retract_EV_fail
    ) &
    failures_MakeGeneralEVFail(General_EV_fail,General_EV_fail_)
      implies
        failures_inv2(
          General_EV_fail_,
          Open_EV_fail,
          Close_EV_fail,
          Extend_EV_fail,
          Retract_EV_fail
        )
  ).

:- dec_p_type(failures_MakeOpenEVFail_inv2).
failures_MakeOpenEVFail_inv2 :-
  dec([General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,
       Retract_EV_fail,Open_EV_fail_],bool) &
  neg(
    failures_inv2(
      General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,Retract_EV_fail
    ) &
    failures_MakeOpenEVFail(Open_EV_fail,Open_EV_fail_)
      implies
        failures_inv2(
          General_EV_fail,
          Open_EV_fail_,
          Close_EV_fail,
          Extend_EV_fail,
          Retract_EV_fail
        )
  ).

:- dec_p_type(failures_MakeCloseEVFail_inv2).
failures_MakeCloseEVFail_inv2 :-
  dec([General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,
       Retract_EV_fail,Close_EV_fail_],bool) &
  neg(
    failures_inv2(
      General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,Retract_EV_fail
    ) &
    failures_MakeCloseEVFail(Close_EV_fail,Close_EV_fail_)
      implies
        failures_inv2(
          General_EV_fail,
          Open_EV_fail,
          Close_EV_fail_,
          Extend_EV_fail,
          Retract_EV_fail
        )
  ).

:- dec_p_type(failures_MakeExtendEVFail_inv2).
failures_MakeExtendEVFail_inv2 :-
  dec([General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,
       Retract_EV_fail,Extend_EV_fail_],bool) &
  neg(
    failures_inv2(
      General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,Retract_EV_fail
    ) &
    failures_MakeExtendEVFail(Extend_EV_fail,Extend_EV_fail_)
      implies
        failures_inv2(
          General_EV_fail,
          Open_EV_fail,
          Close_EV_fail,
          Extend_EV_fail_,
          Retract_EV_fail
        )
  ).

:- dec_p_type(failures_MakeRetractEVFail_inv2).
failures_MakeRetractEVFail_inv2 :-
  dec([General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,
       Retract_EV_fail,Retract_EV_fail_],bool) &
  neg(
    failures_inv2(
      General_EV_fail,Open_EV_fail,Close_EV_fail,Extend_EV_fail,Retract_EV_fail
    ) &
    failures_MakeRetractEVFail(Retract_EV_fail,Retract_EV_fail_)
      implies
        failures_inv2(
          General_EV_fail,
          Open_EV_fail,
          Close_EV_fail,
          Extend_EV_fail,
          Retract_EV_fail_
        )
  ).

:- dec_p_type(failures_MakeDoorCylinderFail_grd1).
failures_MakeDoorCylinderFail_grd1 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec([Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  neg(
    failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Door_cylinder_fail,{}) &
        pfun(Door_cylinder_fail)
  ).

:- dec_p_type(n_failures_inv3(sp,rpb,rpb)).
n_failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) :-
  neg(
    pfun(Door_cylinder_fail) &
    dompf(Door_cylinder_fail,PositionsDG) &
    pfun(Gear_cylinder_fail) &
    dompf(Gear_cylinder_fail,PositionsDG)
  ).

:- dec_p_type(failures_MakeDoorCylinderFail_inv3).
failures_MakeDoorCylinderFail_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_cylinder_fail,Gear_cylinder_fail,Door_cylinder_fail_],rpb) &
  neg(
    failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) &
    failures_MakeDoorCylinderFail(
      PositionsDG,Door_cylinder_fail,Door_cylinder_fail_
    )
      implies
        failures_inv3(PositionsDG,Door_cylinder_fail_,Gear_cylinder_fail)
  ).

:- dec_p_type(failures_MakeGearCylinderFail_grd1).
failures_MakeGearCylinderFail_grd1 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec([Door_cylinder_fail,Gear_cylinder_fail],rpb) &
  neg(
    failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_cylinder_fail,{}) &
        pfun(Gear_cylinder_fail)
  ).

:- dec_p_type(failures_MakeGearCylinderFail_inv3).
failures_MakeGearCylinderFail_inv3 :-
  dec(PositionsDG,sp) &
  dec([Door_cylinder_fail,Gear_cylinder_fail,Gear_cylinder_fail_],rpb) &
  neg(
    failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail) &
    failures_MakeGearCylinderFail(
      PositionsDG,Gear_cylinder_fail,Gear_cylinder_fail_
    )
      implies
        failures_inv3(PositionsDG,Door_cylinder_fail,Gear_cylinder_fail)
  ).



%%% consult('lgs.pl') & lFailuresPO.
:- dec_p_type(check_failures).
check_failures :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking failures_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv3 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv5 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv6 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv7 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv8 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv9 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv10 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_init_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     failures_init_inv11 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_act7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_act7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadHandleSwitchCircuit_act8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadHandleSwitchCircuit_act8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadGearsShock_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadGearsShock_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadGearsShock_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadGearsShock_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadGearsShock_act8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadGearsShock_act8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadGearsShock_act9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadGearsShock_act9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadDoors_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadDoors_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_ReadDoors_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_ReadDoors_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputGEV_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputGEV_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputGEV_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputGEV_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputOpenEV_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputOpenEV_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputCloseEv_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputCloseEv_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputExtendEV_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputExtendEV_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputExtendEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputExtendEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputRetractEV_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputRetractEV_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_OutputRetractEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_OutputRetractEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeGeneralEVFail_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeGeneralEVFail_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeOpenEVFail_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeOpenEVFail_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeCloseEVFail_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeCloseEVFail_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeExtendEVFail_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeExtendEVFail_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeRetractEVFail_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeRetractEVFail_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeDoorCylinderFail_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeDoorCylinderFail_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeDoorCylinderFail_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeDoorCylinderFail_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeGearCylinderFail_grd1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeGearCylinderFail_grd1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking failures_MakeGearCylinderFail_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(failures_MakeGearCylinderFail_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 38) discharged in ') &
     write(T) & write(' seconds') & nl
  ).


















