% Proof obligations of 

% MACHINE Gears

% Run check_gearsIntermediate

:- dec_p_type(gearsIntermediate_inv2_wd).
gearsIntermediate_inv2_wd :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  dec(Po,pos) &
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p) &
          dom(Gear_ext_p,PositionsDG) &
          (applyTo(Gear_ext_p,Po,true)
             implies
               ncomp({[Po,Po]},Gear_ret_p,{}) &
               pfun(Gear_ret_p)
          )
  ).

:- dec_p_type(gearsIntermediate_init_inv1).
gearsIntermediate_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  gearsIntermediate_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p
    ) &
  gearsIntermediate_inv1(PositionsDG,Gear_ret_p).

:- dec_p_type(gearsIntermediate_init_inv2).
gearsIntermediate_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p],rpb) &
  gearsIntermediate_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p
    ) &
  gearsIntermediate_inv2(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p
    ).

:- dec_p_type(gears_start_GearExtend_grd2).
gears_start_GearExtend_grd2 :-
  dec(PositionsDG,sp) &
  dec(Gear_ret_p,rpb) &
  dec(Po,pos) &
  neg(gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ret_p,{}) &
          pfun(Gear_ret_p)
  ).

:- dec_p_type(n_gearsIntermediate_inv1(sp,rpb)).
n_gearsIntermediate_inv1(PositionsDG,Gear_ret_p) :-
  dec(M,sb) &
  neg(pfun(Gear_ret_p) &
      dompf(Gear_ret_p,PositionsDG)
  ).

:- dec_p_type(gearsIntermediate_start_GearExtend_inv1).
gearsIntermediate_start_GearExtend_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ret_p_,Gear_ret_p],rpb) &
  neg(gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      gearsIntermediate_start_GearExtend(
        PositionsDG,
        Gear_ret_p,
        Gear_ret_p_
      )
        implies 
          gearsIntermediate_inv1(PositionsDG,Gear_ret_p_)
  ).

:- dec_p_type(n_gearsIntermediate_inv2(sp,rpb,rpb)).
n_gearsIntermediate_inv2(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p
    ) :-
  neg(foreach(Po in PositionsDG,[M1,M2],
        dec(Po,pos) & 
        dec([M1,M2],bool) &
        (M1 neq true or M2 neq true),
        applyTo(Gear_ext_p,Po,M1) &
        applyTo(Gear_ret_p,Po,M2)
      )
  ).

:- dec_p_type(gearsIntermediate_start_GearExtend_inv2).
gearsIntermediate_start_GearExtend_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ret_p_],rpb) &
  neg(gearsIntermediate_inv2(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p
      ) &
      gearsIntermediate_start_GearExtend(
        PositionsDG,
        Gear_ret_p,
        Gear_ret_p_
      )
        implies
          gearsIntermediate_inv2(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p_
          )
  ).

:- dec_p_type(gears_make_GearExtended_grd2).
gears_make_GearExtended_grd2 :-
  dec(PositionsDG,sp) &
  dec(Gear_ret_p,rpb) &
  dec(Po,pos) &
  neg(gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ret_p,{}) &
          pfun(Gear_ret_p)
  ).

:- dec_p_type(gearsIntermediate_make_GearExtended_inv2).
gearsIntermediate_make_GearExtended_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ext_p_],rpb) &
  neg(gearsIntermediate_inv2(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p
      ) &
      gearsIntermediate_make_GearExtended(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_ext_p_
      )
        implies
          gearsIntermediate_inv2(
            PositionsDG,
            Gear_ext_p_,
            Gear_ret_p
          )
  ).

:- dec_p_type(gearsIntermediate_start_GearRetract_inv2).
gearsIntermediate_start_GearRetract_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ext_p_],rpb) &
  neg(gearsIntermediate_inv2(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p
      ) &
      gearsIntermediate_start_GearRetract(
        PositionsDG,
        Gear_ext_p,
        Gear_ext_p_
      )
        implies
          gearsIntermediate_inv2(
            PositionsDG,
            Gear_ext_p_,
            Gear_ret_p
          )
  ).

:- dec_p_type(gearsIntermediate_make_GearRetracted_grd2).
gearsIntermediate_make_GearRetracted_grd2 :-
  dec(PositionsDG,sp) &
  dec(Gear_ext_p,rpb) &
  dec(Po,pos) & 
  neg(gears_inv1(PositionsDG,Gear_ext_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ext_p,{}) &
          pfun(Gear_ext_p)
  ).

:- dec_p_type(gearsIntermediate_make_GearRetracted_grd3).
gearsIntermediate_make_GearRetracted_grd3 :-
  dec(PositionsDG,sp) &
  dec(Gear_ret_p,rpb) &
  dec(Po,pos) & 
  neg(gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      Po in PositionsDG
        implies
          ncomp({[Po,Po]},Gear_ret_p,{}) &
          pfun(Gear_ret_p)
  ).

:- dec_p_type(gearsIntermediate_make_GearRetracted_inv1).
gearsIntermediate_make_GearRetracted_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ret_p_],rpb) &
  dec(Po,pos) & 
  neg(gearsIntermediate_inv1(PositionsDG,Gear_ret_p) &
      gearsIntermediate_make_GearRetracted(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_ret_p_
     )
       implies
         gearsIntermediate_inv1(PositionsDG,Gear_ret_p_)
  ).

:- dec_p_type(gearsIntermediate_make_GearRetracted_inv2).
gearsIntermediate_make_GearRetracted_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ret_p_],rpb) &
  neg(gearsIntermediate_inv2(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p
      ) &
      gearsIntermediate_make_GearRetracted(
        PositionsDG,
        Gear_ext_p,
        Gear_ret_p,
        Gear_ret_p_
      )
        implies
          gearsIntermediate_inv2(
            PositionsDG,
            Gear_ext_p,
            Gear_ret_p_
          )
  ).

% consult('lgs.pl') & lGearsIntermediatePO.
:- dec_p_type(check_gearsIntermediate).
check_gearsIntermediate :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking gearsIntermediate_inv2_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_inv2_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     gearsIntermediate_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     gearsIntermediate_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_start_GearExtend_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_start_GearExtend_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_start_GearExtend_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_start_GearExtend_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_start_GearExtend_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_start_GearExtend_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gears_make_GearExtended_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gears_make_GearExtended_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_make_GearExtended_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_make_GearExtended_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_start_GearRetract_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_start_GearRetract_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_make_GearRetracted_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_make_GearRetracted_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_make_GearRetracted_grd3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_make_GearRetracted_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_make_GearRetracted_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_make_GearRetracted_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking gearsIntermediate_make_GearRetracted_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(gearsIntermediate_make_GearRetracted_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) & 
     write(' proof obligations (out of 13) discharged in ') &
     write(T) & write(' seconds') & nl
  ).

