% Proof obligations of 

% MACHINE HandleSwitchShockAbsorber

% Run check_handleSwitchShockAbsorber

:- dec_p_type(handleSwitchShockAbsorber_inv11_wd).
handleSwitchShockAbsorber_inv11_wd :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec([Gear_shock_absorber_p,Gear_ext_p],rpb) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    gears_inv1(PositionsDG,Gear_ext_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p) &
        (Po in PositionsDG &
         applyTo(Gear_shock_absorber_p,Po,true)
           implies
             ncomp({[Po,Po]},Gear_ext_p,{}) &
             pfun(Gear_ext_p)
        )
  ).

:- dec_p_type(handleSwitchShockAbsorber_init_inv2).
handleSwitchShockAbsorber_init_inv2 :-
dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
  ) &
  handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p).

:- dec_p_type(handleSwitchShockAbsorber_init_inv7).
handleSwitchShockAbsorber_init_inv7 :-
dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
  ) &
  handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2).

:- dec_p_type(handleSwitchShockAbsorber_init_inv8).
handleSwitchShockAbsorber_init_inv8 :-
dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
  ) &
  handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2).

:- dec_p_type(handleSwitchShockAbsorber_init_inv9).
handleSwitchShockAbsorber_init_inv9 :-
dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
  ) &
  handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1).

:- dec_p_type(handleSwitchShockAbsorber_init_inv11).
handleSwitchShockAbsorber_init_inv11 :-
dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
       Door_cylinder_locked_p,Gear_cylinder_locked_p,Gear_shock_absorber_p],
      rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle],bool) &
  dec(Handle_p,posh) &
  dec(Analogical_switch_p,poss) &
  handleSwitchShockAbsorber_init(
    PositionsDG,
    Gear_ext_p,
    Gear_ret_p,
    Door_open_p,
    Door_closed_p,
    Door_cylinder_locked_p,
    Gear_cylinder_locked_p,
    Circuit_pressurized_p,
    Gear_shock_absorber_p,
    Handle_p,
    Analogical_switch_p,
    Intermediate1,
    Intermediate2,
    Handle
  ) &
  handleSwitchShockAbsorber_inv11(PositionsDG,Gear_ext_p,Gear_shock_absorber_p).

:- dec_p_type(n_handleSwitchShockAbsorber_inv11(sp,rpb,rpb)).
n_handleSwitchShockAbsorber_inv11(PositionsDG,Gear_ext_p,Gear_shock_absorber_p) :-
  neg(
    foreach(Po in PositionsDG,[M1,M2],
      dec(Po,pos) & dec([M1,M2],bool) &
      (M1 = true implies M2 = true),
      applyTo(Gear_shock_absorber_p,Po,M1) &
      applyTo(Gear_ext_p,Po,M2)
    )
  ).

:- dec_p_type(handleSwitchShockAbsorber_make_GearExtended_inv11).
handleSwitchShockAbsorber_make_GearExtended_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_shock_absorber_p,Gear_ret_p,Gear_ext_p_],rpb) &
  dec(Circuit_pressurized_p,bool) &
  neg(
    handleSwitchShockAbsorber_inv11(
      PositionsDG,Gear_ext_p,Gear_shock_absorber_p
    ) &
    handleSwitchShockAbsorber_make_GearExtended(
      PositionsDG,
      Gear_ext_p,
      Circuit_pressurized_p,
      Gear_ret_p,
      Gear_ext_p_
    )
      implies
        handleSwitchShockAbsorber_inv11(
          PositionsDG,Gear_ext_p_,Gear_shock_absorber_p
        )
  ).

:- dec_p_type(n_handleSwitchShockAbsorber_inv2(sp,rpb)).
n_handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) :-
  neg(
    pfun(Gear_shock_absorber_p) &
    dompf(Gear_shock_absorber_p,PositionsDG)
  ).

:- dec_p_type(handleSwitchShockAbsorber_start_GearRetract_inv2).
handleSwitchShockAbsorber_start_GearRetract_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_shock_absorber_p,
       Door_open_p,
       Gear_cylinder_locked_p,Gear_ext_p_,Gear_shock_absorber_p_],rpb) &
  dec(Circuit_pressurized_p,bool) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    handleSwitchShockAbsorber_start_GearRetract(
      PositionsDG,
      Gear_ext_p,
      Door_open_p,
      Gear_shock_absorber_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Gear_ext_p_,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_start_GearRetract_inv11).
handleSwitchShockAbsorber_start_GearRetract_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_shock_absorber_p,
       Door_open_p,
       Gear_cylinder_locked_p,Gear_ext_p_,Gear_shock_absorber_p_],rpb) &
  dec(Circuit_pressurized_p,bool) &
  neg(
    handleSwitchShockAbsorber_inv11(
      PositionsDG,Gear_ext_p,Gear_shock_absorber_p
    ) &
    handleSwitchShockAbsorber_start_GearRetract(
      PositionsDG,
      Gear_ext_p,
      Door_open_p,
      Gear_shock_absorber_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Gear_ext_p_,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv11(
          PositionsDG,Gear_ext_p_,Gear_shock_absorber_p_
        )
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd2).
handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd2 :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec(Gear_shock_absorber_p,rpb) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p)
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd3).
handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd3 :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec(Gear_ext_p,rpb) &
  neg(
    gears_inv1(PositionsDG,Gear_ext_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_ext_p,{}) &
        pfun(Gear_ext_p)
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv2).
handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_shock_absorber_p,Gear_shock_absorber_p_],rpb) &
  dec(Handle_p,posh) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    handleSwitchShockAbsorber_Make_GearAbsorberTrue(
      PositionsDG,
      Gear_ext_p,
      Gear_shock_absorber_p,
      Handle_p,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv11).
handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_shock_absorber_p,Gear_shock_absorber_p_],rpb) &
  dec(Handle_p,posh) &
  neg(
    handleSwitchShockAbsorber_inv11(
      PositionsDG,Gear_ext_p,Gear_shock_absorber_p
    ) &
    handleSwitchShockAbsorber_Make_GearAbsorberTrue(
      PositionsDG,
      Gear_ext_p,
      Gear_shock_absorber_p,
      Handle_p,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv11(
          PositionsDG,Gear_ext_p,Gear_shock_absorber_p_
        )
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberFalse_grd2).
handleSwitchShockAbsorber_Make_GearAbsorberFalse_grd2 :-
  dec(PositionsDG,sp) &
  dec(Po,pos) &
  dec(Gear_shock_absorber_p,rpb) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},Gear_shock_absorber_p,{}) &
        pfun(Gear_shock_absorber_p)
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv2).
handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_shock_absorber_p,Gear_shock_absorber_p_],rpb) &
  neg(
    handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p) &
    handleSwitchShockAbsorber_Make_GearAbsorberFalse(
      PositionsDG,
      Gear_shock_absorber_p,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv2(PositionsDG,Gear_shock_absorber_p_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv11).
handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,
       Gear_shock_absorber_p,Gear_shock_absorber_p_],rpb) &
  neg(
    handleSwitchShockAbsorber_inv11(
      PositionsDG,Gear_ext_p,Gear_shock_absorber_p
    ) &
    handleSwitchShockAbsorber_Make_GearAbsorberFalse(
      PositionsDG,
      Gear_shock_absorber_p,
      Gear_shock_absorber_p_
    )
      implies
        handleSwitchShockAbsorber_inv11(
          PositionsDG,Gear_ext_p,Gear_shock_absorber_p_
        )
  ).

:- dec_p_type(n_handleSwitchShockAbsorber_inv7(bool,bool)).
n_handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) :-
  neg(
    neg(Intermediate1 = true & Intermediate2 = true)
  ).

:- dec_p_type(handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv7).
handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv7 :-
  dec(Analogical_switch_p,poss) &
  dec([Intermediate1,Intermediate2,Handle,Intermediate1_,Handle_],bool) &
  neg(
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_HandleFromOpenToIntermediate1(
      Analogical_switch_p,
      Intermediate1,
      Intermediate2,
      Handle,
      Intermediate1_,
      Handle_
    )
      implies
        handleSwitchShockAbsorber_inv7(Intermediate1_,Intermediate2)
  ).

:- dec_p_type(n_handleSwitchShockAbsorber_inv9(poss,bool)).
n_handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) :-
  neg(
    Intermediate1 = true implies Analogical_switch_p = open
  ).

:- dec_p_type(handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv9).
handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv9 :-
  dec(Analogical_switch_p,poss) &
  dec([Intermediate1,Intermediate2,Handle,Intermediate1_,Handle_],bool) &
  neg(
    handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) &
    handleSwitchShockAbsorber_HandleFromOpenToIntermediate1(
      Analogical_switch_p,
      Intermediate1,
      Intermediate2,
      Handle,
      Intermediate1_,
      Handle_
    )
      implies
        handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_close_Switch_inv7).
handleSwitchShockAbsorber_close_Switch_inv7 :-
  dec(Analogical_switch_p_,poss) &
  dec([Intermediate1,Intermediate2,Intermediate1_],bool) &
  neg(
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_close_Switch(
      Intermediate1,
      Analogical_switch_p_,
      Intermediate1_
    )
      implies
        handleSwitchShockAbsorber_inv7(Intermediate1_,Intermediate2)
  ).

:- dec_p_type(n_handleSwitchShockAbsorber_inv8(poss,bool)).
n_handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) :-
  neg(
    Intermediate2 = true implies Analogical_switch_p = open
  ).

:- dec_p_type(handleSwitchShockAbsorber_close_Switch_inv8).
handleSwitchShockAbsorber_close_Switch_inv8 :-
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  dec([Intermediate1,Intermediate2,Intermediate1_],bool) &
  neg(
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) &
    handleSwitchShockAbsorber_close_Switch(
      Intermediate1,
      Analogical_switch_p_,
      Intermediate1_
    )
      implies
        handleSwitchShockAbsorber_inv8(Analogical_switch_p_,Intermediate2)
  ).

:- dec_p_type(handleSwitchShockAbsorber_close_Switch_inv9).
handleSwitchShockAbsorber_close_Switch_inv9 :-
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  dec([Intermediate1,Intermediate1_],bool) &
  neg(
    handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) &
    handleSwitchShockAbsorber_close_Switch(
      Intermediate1,
      Analogical_switch_p_,
      Intermediate1_
    )
      implies
        handleSwitchShockAbsorber_inv9(Analogical_switch_p_,Intermediate1_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv7).
handleSwitchShockAbsorber_FromCloseToIntermediate2_inv7 :-
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  dec([Intermediate1,Intermediate2,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) &
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_FromCloseToIntermediate2(
      Analogical_switch_p,
      Analogical_switch_p_,
      Intermediate2_
    )
      implies
        handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv8).
handleSwitchShockAbsorber_FromCloseToIntermediate2_inv8 :-
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  dec([Intermediate2,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) &
    handleSwitchShockAbsorber_FromCloseToIntermediate2(
      Analogical_switch_p,
      Analogical_switch_p_,
      Intermediate2_
    )
      implies
        handleSwitchShockAbsorber_inv8(Analogical_switch_p_,Intermediate2_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv9).
handleSwitchShockAbsorber_FromCloseToIntermediate2_inv9 :-
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  dec([Intermediate1,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) &
    handleSwitchShockAbsorber_FromCloseToIntermediate2(
      Analogical_switch_p,
      Analogical_switch_p_,
      Intermediate2_
    )
      implies
        handleSwitchShockAbsorber_inv9(Analogical_switch_p_,Intermediate1)
  ).

:- dec_p_type(
     handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv7).
handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv7 :-
  dec([Handle,
       Intermediate1,Intermediate2,Handle_,Intermediate1_,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1(
      Intermediate2,
      Handle,
      Intermediate1_,
      Intermediate2_,
      Handle_
    )
      implies
        handleSwitchShockAbsorber_inv7(Intermediate1_,Intermediate2_)
  ).

:- dec_p_type(
     handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv8).
handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv8 :-
  dec(Analogical_switch_p,poss) &
  dec([Handle,Intermediate2,Handle_,Intermediate1_,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) &
    handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1(
      Intermediate2,
      Handle,
      Intermediate1_,
      Intermediate2_,
      Handle_
    )
      implies
        handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2_)
  ).

:- dec_p_type(
     handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv9).
handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv9 :-
  dec(Analogical_switch_p,poss) &
  dec([Handle,
       Intermediate1,Intermediate2,Handle_,Intermediate1_,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) &
    handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1) &
    handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1(
      Intermediate2,
      Handle,
      Intermediate1_,
      Intermediate2_,
      Handle_
    )
      implies
        handleSwitchShockAbsorber_inv9(Analogical_switch_p,Intermediate1_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_open_Switch_inv7).
handleSwitchShockAbsorber_open_Switch_inv7 :-
  dec([Intermediate1,Intermediate2,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2) &
    handleSwitchShockAbsorber_open_Switch(
      Intermediate2,
      Intermediate2_
    )
      implies
        handleSwitchShockAbsorber_inv7(Intermediate1,Intermediate2_)
  ).

:- dec_p_type(handleSwitchShockAbsorber_open_Switch_inv8).
handleSwitchShockAbsorber_open_Switch_inv8 :-
  dec(Analogical_switch_p,poss) &
  dec([Intermediate2,Intermediate2_],bool) &
  neg(
    handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2) &
    handleSwitchShockAbsorber_open_Switch(
      Intermediate2,
      Intermediate2_
    )
      implies
        handleSwitchShockAbsorber_inv8(Analogical_switch_p,Intermediate2_)
  ).


% consult('lgs.pl') & lHandleSwitchShockAbsorberPO.
:- dec_p_type(check_handleSwitchShockAbsorber).
check_handleSwitchShockAbsorber :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking handleSwitchShockAbsorber_inv11_wd...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_inv11_wd) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     handleSwitchShockAbsorber_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_init_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     handleSwitchShockAbsorber_init_inv7 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_init_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     handleSwitchShockAbsorber_init_inv8 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_init_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     handleSwitchShockAbsorber_init_inv9 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_init_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     handleSwitchShockAbsorber_init_inv11 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_make_GearExtended_inv11...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_make_GearExtended_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_start_GearRetract_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_start_GearRetract_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking handleSwitchShockAbsorber_start_GearRetract_inv11...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_start_GearRetract_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd3...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberTrue_grd3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv2...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberTrue_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberFalse_grd2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberFalse_grd2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_Make_GearAbsorberFalse_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_HandleFromOpenToIntermediate1_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_close_Switch_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_close_Switch_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_close_Switch_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_close_Switch_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_close_Switch_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_close_Switch_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_FromCloseToIntermediate2_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_FromCloseToIntermediate2_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_FromCloseToIntermediate2_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_FromCloseToIntermediate2_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_') &
       write('HandleFromIntermediate2ToIntermediate1_inv7') &
     write('...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_') &
       write('HandleFromIntermediate2ToIntermediate1_inv8') &
     write('...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('handleSwitchShockAbsorber_') &
       write('HandleFromIntermediate2ToIntermediate1_inv9') &
     write('...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_HandleFromIntermediate2ToIntermediate1_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_open_Switch_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_open_Switch_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking handleSwitchShockAbsorber_open_Switch_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(handleSwitchShockAbsorber_open_Switch_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 29) discharged in ') &
     write(T) & write(' seconds') & nl
  ).







