% Proof obligations of 

% MACHINE TimedAspects

% Run check_timedAspects

:- dec_p_type(timedAspects_init_inv1).
timedAspects_init_inv1 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv1(CurrentTime).

:- dec_p_type(timedAspects_init_inv2).
timedAspects_init_inv2 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv2(DeadlineSwitch).

:- dec_p_type(timedAspects_init_inv3).
timedAspects_init_inv3 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv3(DeadlineStimulationGeneralEv).

:- dec_p_type(timedAspects_init_inv4).
timedAspects_init_inv4 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv4(DeadlineStimulationOpenCloseEv).

:- dec_p_type(timedAspects_init_inv5).
timedAspects_init_inv5 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders).

:- dec_p_type(timedAspects_init_inv6).
timedAspects_init_inv6 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders).

:- dec_p_type(timedAspects_init_inv7).
timedAspects_init_inv7 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors).

:- dec_p_type(timedAspects_init_inv8).
timedAspects_init_inv8 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv8(DeadlineStimulationRetExtEv).

:- dec_p_type(timedAspects_init_inv9).
timedAspects_init_inv9 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending).

:- dec_p_type(timedAspects_init_inv10).
timedAspects_init_inv10 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv10(AllowedStopGeneralEv).

:- dec_p_type(timedAspects_init_inv11).
timedAspects_init_inv11 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv11(AllowedStartOpenEv).

:- dec_p_type(timedAspects_init_inv12).
timedAspects_init_inv12 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv12(AllowedStartCloseEv).

:- dec_p_type(timedAspects_init_inv13).
timedAspects_init_inv13 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv13(AllowedStartExtEv).

:- dec_p_type(timedAspects_init_inv14).
timedAspects_init_inv14 :-
  dec(PositionsDG,sp) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,Door_cylinder_locked_p,
       Gear_cylinder_locked_p,Gear_shock_absorber_p,Gear_extended_ind,
       Gear_shock_absorber_ind,Gear_retracted_ind,Door_closed_ind,
       Door_open_ind],rpb) &
  dec([Circuit_pressurized_p,Intermediate1,Intermediate2,Handle,General_EV_p,
       Open_EV_p,Close_EV_p,Extend_EV_p,Retract_EV_p,GreenLight_p,OrangeLight_p,
       RedLight_p,Circuit_pressurized_ind,General_EV,Open_EV,Close_EV,Extend_EV,
       Retract_EV,Gears_locked_down,Gears_maneuvering,End_cycle],bool) &
  dec([Handle_p,Handle_ind],posh) &
  dec([Analogical_switch_p,Analogical_switch_ind],poss) &
  dec([CurrentTime,DeadlineSwitch,DeadlineStimulationGeneralEv,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv,
       AllowedStopGeneralEv,AllowedStartOpenEv,AllowedStartCloseEv,
       AllowedStartExtEv,AllowedStartRetEv],int) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineGearsRetractingExtending,DeadlineUnlockLockDoorsCylinders],rpi) &
  timedAspects_init(
    PositionsDG,Gear_ext_p,Gear_ret_p,Door_open_p,Door_closed_p,
    Door_cylinder_locked_p,Gear_cylinder_locked_p,Circuit_pressurized_p,
    Gear_shock_absorber_p,Handle_p,Analogical_switch_p,Intermediate1,
    Intermediate2,Handle,General_EV_p,Open_EV_p,Close_EV_p,Extend_EV_p,
    Retract_EV_p,GreenLight_p,OrangeLight_p,RedLight_p,Handle_ind,
    Analogical_switch_ind,Circuit_pressurized_ind, General_EV,Open_EV,Close_EV,
    Extend_EV,Retract_EV,Gear_extended_ind,Gear_shock_absorber_ind,
    Gear_retracted_ind,Door_closed_ind,Door_open_ind,Gears_locked_down,
    Gears_maneuvering,End_cycle,CurrentTime,DeadlineSwitch,
    DeadlineStimulationGeneralEv,DeadlineStimulationOpenCloseEv,
    DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockGearsCylinders,
    DeadlineOpenCloseDoors,DeadlineStimulationRetExtEv,
    DeadlineGearsRetractingExtending,AllowedStopGeneralEv,AllowedStartOpenEv,
    AllowedStartCloseEv,AllowedStartExtEv,AllowedStartRetEv
  ) &
  timedAspects_inv14(AllowedStartRetEv).

:- dec_p_type(timedAspects_start_GearExtend_grd8).
timedAspects_start_GearExtend_grd8 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockGearsCylinders,rpi) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockGearsCylinders,{}) &
        pfun(DeadlineUnlockLockGearsCylinders)
  ).

:- dec_p_type(n_timedAspects_inv9(sp,rpi)).
n_timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) :-
  neg(
    pfun(DeadlineGearsRetractingExtending) &
    dompf(DeadlineGearsRetractingExtending,PositionsDG) &
    foreach(
      [X,Y] in DeadlineGearsRetractingExtending, dec(X,pos) & dec(Y,int) & 0 =< Y
    )
  ).

:- dec_p_type(timedAspects_start_GearExtend_inv9).
timedAspects_start_GearExtend_inv9 :-
  dec(PositionsDG,sp) &
  dec([DeadlineGearsRetractingExtending,DeadlineUnlockLockGearsCylinders,
       DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ret_p,Door_open_p,Gear_cylinder_locked_p,Gear_ret_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    timedAspects_start_GearExtend(
      PositionsDG,
      Gear_ret_p,
      Door_open_p,
      Gear_cylinder_locked_p,
      Extend_EV_p,
      Retract_EV_p,
      Circuit_pressurized_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      Gear_ret_p_,
      DeadlineGearsRetractingExtending_
    )
      implies
        timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending_)
  ).

:- dec_p_type(timedAspects_start_GearExtend_act2).
timedAspects_start_GearExtend_act2 :-
  dec(PositionsDG,sp) &
  dec([M2,M3,CurrentTime],int) &
  dec(Po,pos) &
  neg(
    PositionsDG = {front,left,right} &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16 &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},{[front,M2],[left,M3],[right,16]},{}) &
        pfun({[front,M2],[left,M3],[right,16]})
  ).

:- dec_p_type(timedAspects_make_GearExtended_grd6).
timedAspects_make_GearExtended_grd6 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineGearsRetractingExtending,rpi) &
  neg(
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},DeadlineGearsRetractingExtending,{}) &
        pfun(DeadlineGearsRetractingExtending)
  ).
    
:- dec_p_type(n_timedAspects_inv6(sp,rpi)).
n_timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) :-
  neg(
    pfun(DeadlineUnlockLockGearsCylinders) &
    dompf(DeadlineUnlockLockGearsCylinders,PositionsDG) &
    foreach(
      [X,Y] in DeadlineUnlockLockGearsCylinders, dec(X,pos) & dec(Y,int) & 0 =< Y
    )
  ).

:- dec_p_type(timedAspects_make_GearExtended_inv6).
timedAspects_make_GearExtended_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_,
       DeadlineGearsRetractingExtending,DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ext_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_make_GearExtended(
      PositionsDG,
      Gear_ext_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ret_p,
      CurrentTime,
      DeadlineGearsRetractingExtending,
      DeadlineUnlockLockGearsCylinders,
      Gear_ext_p_,
      DeadlineGearsRetractingExtending_,
      DeadlineUnlockLockGearsCylinders_
    )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(timedAspects_make_GearExtended_inv9).
timedAspects_make_GearExtended_inv9 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_,
       DeadlineGearsRetractingExtending,DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ext_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    timedAspects_make_GearExtended(
      PositionsDG,
      Gear_ext_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ret_p,
      CurrentTime,
      DeadlineGearsRetractingExtending,
      DeadlineUnlockLockGearsCylinders,
      Gear_ext_p_,
      DeadlineGearsRetractingExtending_,
      DeadlineUnlockLockGearsCylinders_
    )
      implies
        timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending_)
  ).

:- dec_p_type(timedAspects_start_GearRetract_grd8).
timedAspects_start_GearRetract_grd8 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockGearsCylinders,rpi) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockGearsCylinders,{}) &
        pfun(DeadlineUnlockLockGearsCylinders)
  ).

:- dec_p_type(timedAspects_start_GearRetract_inv6).
timedAspects_start_GearRetract_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending,
       DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Door_open_p,Gear_cylinder_locked_p,Gear_shock_absorber_p,
       Gear_ext_p_,Gear_shock_absorber_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    timedAspects_start_GearRetract(
      PositionsDG,
      Gear_ext_p,
      Door_open_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ext_p_,
      Gear_shock_absorber_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      Gear_shock_absorber_p_,
      DeadlineGearsRetractingExtending_
    )
      implies
        timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending_)
  ).

:- dec_p_type(timedAspects_start_GearRetract_inv9).
timedAspects_start_GearRetract_inv9 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending,
       DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Door_open_p,Gear_cylinder_locked_p,Gear_shock_absorber_p,
       Gear_ext_p_,Gear_shock_absorber_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    timedAspects_start_GearRetract(
      PositionsDG,
      Gear_ext_p,
      Door_open_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      Gear_ext_p_,
      Gear_shock_absorber_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      Gear_shock_absorber_p_,
      DeadlineGearsRetractingExtending_
    )
      implies
        timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending_)
  ).

:- dec_p_type(timedAspects_start_GearRetract_act3).
timedAspects_start_GearRetract_act3 :-
  dec(PositionsDG,sp) &
  dec([M2,M3,CurrentTime],int) &
  dec(Po,pos) &
  neg(
    PositionsDG = {front,left,right} &
    M2 is CurrentTime + 16 &
    M3 is CurrentTime + 20 &
    Po in PositionsDG
      implies
        ncomp({[Po,Po]},{[front,M2],[left,M3],[right,M3]},{}) &
        pfun({[front,M2],[left,M3],[right,M3]})
  ).

:- dec_p_type(timedAspects_make_GearRetracted_grd7).
timedAspects_start_GearRetract_grd8 :-
  dec([PositionsDG,M],sp) &
  dec(DeadlineGearsRetractingExtending,rpi) &
  neg(
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    PositionsDG = {front / M}
      implies
        ncomp({[front,front]},DeadlineGearsRetractingExtending,{}) &
        pfun(DeadlineGearsRetractingExtending)
  ).

:- dec_p_type(timedAspects_make_GearRetracted_inv6).
timedAspects_make_GearRetracted_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_,
       DeadlineGearsRetractingExtending,DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ret_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_make_GearRetracted(
      PositionsDG,
      Gear_ext_p,
      Gear_ret_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      Gear_ret_p_,
      DeadlineUnlockLockGearsCylinders_,
      DeadlineGearsRetractingExtending_
    )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(timedAspects_make_GearRetracted_inv9).
timedAspects_make_GearRetracted_inv9 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_,
       DeadlineGearsRetractingExtending,DeadlineGearsRetractingExtending_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Gear_ret_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    timedAspects_make_GearRetracted(
      PositionsDG,
      Gear_ext_p,
      Gear_ret_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      Gear_ret_p_,
      DeadlineUnlockLockGearsCylinders_,
      DeadlineGearsRetractingExtending_
    )
      implies
        timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending_)
  ).

:- dec_p_type(timedAspects_start_DoorOpening_grd6).
timedAspects_start_DoorOpening_grd6 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockDoorsCylinders,rpi) &
  dec(Door_closed_p,rpb) &
  neg(
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    applyTo(Door_closed_p,Po,true) &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p)
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockDoorsCylinders,{}) &
        pfun(DeadlineUnlockLockDoorsCylinders)
  ).

:- dec_p_type(n_timedAspects_inv7(sp,rpi)).
n_timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) :-
  neg(
    pfun(DeadlineOpenCloseDoors) &
    dompf(DeadlineOpenCloseDoors,PositionsDG) &
    foreach(
      [X,Y] in DeadlineOpenCloseDoors, dec(X,pos) & dec(Y,int) & 0 =< Y
    )
  ).

:- dec_p_type(timedAspects_start_DoorOpening_inv7).
timedAspects_start_DoorOpening_inv7 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineOpenCloseDoors,
       DeadlineOpenCloseDoors_],rpi) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_closed_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    PositionsDG = {front,left,right} &
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    timedAspects_start_DoorOpening(
      Door_closed_p,
      Door_cylinder_locked_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      DeadlineOpenCloseDoors,
      Door_closed_p_,
      DeadlineOpenCloseDoors_
    )
      implies
        timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors_)
  ).

:- dec_p_type(timedAspects_start_DoorOpening_act2).
timedAspects_start_DoorOpening_act2 :-
  dec(PositionsDG,sp) &
  dec([M2,M3,CurrentTime],int) &
  dec(Po,pos) &
  dec(Door_closed_p,rpb) &
  neg(
    PositionsDG = {front,left,right} &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 15 &
    applyTo(Door_closed_p,Po,true) &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p)
      implies
        ncomp({[Po,Po]},{[front,M2],[left,M3],[right,M3]},{}) &
        pfun({[front,M2],[left,M3],[right,M3]})
  ).

:- dec_p_type(timedAspects_make_DoorOpen_grd9).
timedAspects_make_DoorOpen_grd9 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineOpenCloseDoors,rpi) &
  dec(Door_open_p,rpb) &
  neg(
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    applyTo(Door_open_p,Po,false) &
    doors_inv1(PositionsDG,Door_open_p)
      implies
        ncomp({[Po,Po]},DeadlineOpenCloseDoors,{}) &
        pfun(DeadlineOpenCloseDoors)
  ).

:- dec_p_type(timedAspects_make_DoorOpen_inv7).
timedAspects_start_DoorOpening_inv7 :-
  dec(PositionsDG,sp) &
  dec([DeadlineOpenCloseDoors,DeadlineOpenCloseDoors_],rpi) &
  dec([Door_open_p,Door_closed_p,Door_open_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    timedAspects_make_DoorOpen(
      Door_open_p,
      Door_closed_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineOpenCloseDoors,
      Door_open_p_,
      DeadlineOpenCloseDoors_
    )
      implies
        timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors_)
  ).

:- dec_p_type(timedAspects_start_DoorClosing_inv7).
timedAspects_start_DoorClosing_inv7 :-
  dec(PositionsDG,sp) &
  dec([DeadlineOpenCloseDoors,DeadlineOpenCloseDoors_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_cylinder_locked_p,
       Door_open_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    timedAspects_start_DoorClosing(
      PositionsDG,
      Gear_ext_p,
      Gear_ret_p,
      Door_open_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineOpenCloseDoors,
      Door_open_p_,
      DeadlineOpenCloseDoors_
    )
      implies
        timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors_)
  ).

:- dec_p_type(timedAspects_start_DoorClosing_act2).
timedAspects_start_DoorClosing_act2 :-
  dec(PositionsDG,sp) &
  dec([M2,M3,CurrentTime],int) &
  dec(Po,pos) &
  dec(Door_open_p,rpb) &
  neg(
    PositionsDG = {front,left,right} &
    M2 is CurrentTime + 12 &
    M3 is CurrentTime + 16 &
    applyTo(Door_open_p,Po,true) &
    doors_inv1(PositionsDG,Door_open_p)
      implies
        ncomp({[Po,Po]},{[front,M2],[left,M3],[right,M3]},{}) &
        pfun({[front,M2],[left,M3],[right,M3]})
  ).

:- dec_p_type(timedAspects_make_DoorClosed_grd6).
timedAspects_make_DoorClosed_grd6 :-
  dec(Po,pos) &
  dec(PositionsDG,sp) &
  dec(DeadlineOpenCloseDoors,rpi) &
  dec(Door_closed_p,rpb) &
  neg(
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    applyTo(Door_closed_p,Po,false) &
    doorsIntermediate_inv1(PositionsDG,Door_closed_p)
      implies
        ncomp({[Po,Po]},DeadlineOpenCloseDoors,{}) &
        pfun(DeadlineOpenCloseDoors)
  ).

:- dec_p_type(n_timedAspects_inv5(sp,rpi)).
n_timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) :-
  neg(
    pfun(DeadlineUnlockLockDoorsCylinders) &
    dompf(DeadlineUnlockLockDoorsCylinders,PositionsDG) &
    foreach(
      [X,Y] in DeadlineUnlockLockDoorsCylinders, dec(X,pos) & dec(Y,int) & 0 =< Y
    )
  ).

:- dec_p_type(timedAspects_make_DoorClosed_inv5).
timedAspects_make_DoorClosed_inv5 :-
  dec(PositionsDG,sp) &
  dec([DeadlineOpenCloseDoors,DeadlineOpenCloseDoors_,
       DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockDoorsCylinders_],rpi) &
  dec([Door_open_p,Door_closed_p,Door_closed_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    doorsIntermediate_inv1(PositionsDG,Door_closed_p) &
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    timedAspects_make_DoorClosed(
      Door_open_p,
      Door_closed_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      Door_closed_p_,
      DeadlineOpenCloseDoors_,
      DeadlineUnlockLockDoorsCylinders_
    )
      implies
        timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders_)
  ).

:- dec_p_type(timedAspects_make_DoorClosed_inv7).
timedAspects_make_DoorClosed_inv7 :-
  dec(PositionsDG,sp) &
  dec([DeadlineOpenCloseDoors,DeadlineOpenCloseDoors_,
       DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockDoorsCylinders_],rpi) &
  dec([Door_open_p,Door_closed_p,Door_closed_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    timedAspects_make_DoorClosed(
      Door_open_p,
      Door_closed_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      Door_closed_p_,
      DeadlineOpenCloseDoors_,
      DeadlineUnlockLockDoorsCylinders_
    )
      implies
        timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors_)
  ).

:- dec_p_type(timedAspects_LockGearCylinder_grd6).
timedAspects_LockGearCylinder_grd6 :-
  dec([PositionsDG,M],sp) &
  dec(DeadlineUnlockLockGearsCylinders,rpi) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    PositionsDG = {front / M} 
      implies
        ncomp({[front,front]},DeadlineUnlockLockGearsCylinders,{}) &
        pfun(DeadlineUnlockLockGearsCylinders)
  ).

:- dec_p_type(timedAspects_LockGearCylinder_inv6).
timedAspects_LockGearCylinder_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Gear_cylinder_locked_p,
       Gear_cylinder_locked_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_LockGearCylinder(
      PositionsDG,
      Gear_ext_p,
      Gear_ret_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      Gear_cylinder_locked_p_,
      DeadlineUnlockLockGearsCylinders_
    )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(timedAspects_UnlockDoorCylinder_grd7).
timedAspects_UnlockDoorCylinder_grd7 :-
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockDoorsCylinders,rpi) &
  dec(Po,pos) &
  neg(
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    Po in PositionsDG 
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockDoorsCylinders,{}) &
        pfun(DeadlineUnlockLockDoorsCylinders)
  ).

:- dec_p_type(timedAspects_UnlockDoorCylinder_inv5).
timedAspects_UnlockDoorCylinder_inv5 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockDoorsCylinders_],rpi) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    timedAspects_UnlockDoorCylinder(
      PositionsDG,
      Door_closed_p,
      Door_cylinder_locked_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineUnlockLockDoorsCylinders,
      Door_cylinder_locked_p_,
      DeadlineUnlockLockDoorsCylinders_
    )
      implies
        timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders_)
  ).

:- dec_p_type(timedAspects_LockDoorCylinder_grd7).
timedAspects_LockDoorCylinder_grd7 :-
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockDoorsCylinders,rpi) &
  dec(Po,pos) &
  neg(
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    Po in PositionsDG 
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockDoorsCylinders,{}) &
        pfun(DeadlineUnlockLockDoorsCylinders)
  ).

:- dec_p_type(timedAspects_LockDoorCylinder_inv5).
timedAspects_LockDoorCylinder_inv5 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockDoorsCylinders_],rpi) &
  dec([Door_closed_p,Door_cylinder_locked_p,Door_cylinder_locked_p_],rpb) &
  dec([Open_EV_p,Close_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    timedAspects_LockDoorCylinder(
      PositionsDG,
      Door_closed_p,
      Door_cylinder_locked_p,
      Circuit_pressurized_p,
      Open_EV_p,
      Close_EV_p,
      CurrentTime,
      DeadlineUnlockLockDoorsCylinders,
      Door_cylinder_locked_p_,
      DeadlineUnlockLockDoorsCylinders_
    )
      implies
        timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders_)
  ).

:- dec_p_type(timedAspects_UnlockGearCylinder_grd7).
timedAspects_UnlockGearCylinder_grd7 :-
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockGearsCylinders,rpi) &
  dec(Po,pos) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    Po in PositionsDG 
      implies
        ncomp({[Po,Po]},DeadlineUnlockLockGearsCylinders,{}) &
        pfun(DeadlineUnlockLockGearsCylinders)
  ).

:- dec_p_type(timedAspects_UnlockGearCylinder_inv6).
timedAspects_UnlockGearCylinder_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_],rpi) &
  dec([Gear_ext_p,Gear_ret_p,Door_open_p,Gear_cylinder_locked_p,
       Gear_cylinder_locked_p_],rpb) &
  dec([Extend_EV_p,Retract_EV_p,Circuit_pressurized_p],bool) &
  dec(CurrentTime,int) &
  neg(
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_UnlockGearCylinder(
      PositionsDG,
      Gear_ext_p,
      Gear_ret_p,
      Door_open_p,
      Gear_cylinder_locked_p,
      Circuit_pressurized_p,
      Extend_EV_p,
      Retract_EV_p,
      CurrentTime,
      DeadlineUnlockLockGearsCylinders,
      Gear_cylinder_locked_p_,
      DeadlineUnlockLockGearsCylinders_
     )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(n_timedAspects_inv3(int)).
n_timedAspects_inv3(DeadlineStimulationGeneralEv) :-
  neg(0 =< DeadlineStimulationGeneralEv).

:- dec_p_type(timedAspects_MakeGeneralValveActive_inv3).
timedAspects_MakeGeneralValveActive_inv3 :-
  dec([CurrentTime,DeadlineStimulationGeneralEv,
       DeadlineStimulationGeneralEv_],int) &
  dec([General_EV_p,General_EV,General_EV_p_],bool) &
  neg(
    timedAspects_inv3(DeadlineStimulationGeneralEv) &
    timedAspects_MakeGeneralValveActive(
      General_EV_p,
      General_EV,
      CurrentTime,
      DeadlineStimulationGeneralEv,
      General_EV_p_,
      DeadlineStimulationGeneralEv_
     )
      implies
        timedAspects_inv3(DeadlineStimulationGeneralEv_)
  ).

:- dec_p_type(timedAspects_MakeGeneralValveNoActive_inv3).
timedAspects_MakeGeneralValveNoActive_inv3 :-
  dec([CurrentTime,DeadlineStimulationGeneralEv,
       DeadlineStimulationGeneralEv_],int) &
  dec([General_EV_p,General_EV,General_EV_p_],bool) &
  neg(
    timedAspects_inv3(DeadlineStimulationGeneralEv) &
    timedAspects_MakeGeneralValveNoActive(
      General_EV_p,
      General_EV,
      CurrentTime,
      DeadlineStimulationGeneralEv,
      General_EV_p_,
      DeadlineStimulationGeneralEv_
     )
      implies
        timedAspects_inv3(DeadlineStimulationGeneralEv_)
  ).

:- dec_p_type(n_timedAspects_inv4(int)).
n_timedAspects_inv4(DeadlineStimulationOpenCloseEv) :-
  neg(0 =< DeadlineStimulationOpenCloseEv).

:- dec_p_type(timedAspects_MakeOpenDoorValveActive_inv4).
timedAspects_MakeOpenDoorValveActive_inv4 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,
       DeadlineStimulationOpenCloseEv_],int) &
  dec([Circuit_pressurized_p,Open_EV_p,Open_EV,Open_EV_p_],bool) &
  dec(DeadlineUnlockLockDoorsCylinders_,rpi) &
  neg(
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_MakeOpenDoorValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Open_EV_p,
      Open_EV,
      CurrentTime,
      Open_EV_p_,
      DeadlineStimulationOpenCloseEv_,
      DeadlineUnlockLockDoorsCylinders_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(timedAspects_MakeOpenDoorValveActive_inv5).
timedAspects_MakeOpenDoorValveActive_inv5 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,
       DeadlineStimulationOpenCloseEv_],int) &
  dec([Circuit_pressurized_p,Open_EV_p,Open_EV,Open_EV_p_],bool) &
  dec([DeadlineUnlockLockDoorsCylinders,DeadlineUnlockLockDoorsCylinders_],rpi) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    timedAspects_MakeOpenDoorValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Open_EV_p,
      Open_EV,
      CurrentTime,
      Open_EV_p_,
      DeadlineStimulationOpenCloseEv_,
      DeadlineUnlockLockDoorsCylinders_
     )
      implies
        timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders_)
  ).

:- dec_p_type(timedAspects_MakeOpenDoorValveNoActive_inv4).
timedAspects_MakeOpenDoorValveNoActive_inv4 :-
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,
       DeadlineStimulationOpenCloseEv_],int) &
  dec([Open_EV_p,Open_EV,Open_EV_p_],bool) &
  dec(DeadlineUnlockLockDoorsCylinders_,rpi) &
  neg(
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_MakeOpenDoorValveNoActive(
      Open_EV_p,
      Open_EV,
      CurrentTime,
      DeadlineStimulationOpenCloseEv,
      Open_EV_p_,
      DeadlineStimulationOpenCloseEv_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(timedAspects_MakeCloseDoorValveActive_inv4).
timedAspects_MakeCloseDoorValveActive_inv4 :-
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,
       DeadlineStimulationOpenCloseEv_],int) &
  dec([Circuit_pressurized_p,Close_EV_p,Close_EV,Close_EV_p_],bool) &
  dec(DeadlineUnlockLockDoorsCylinders_,rpi) &
  neg(
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_MakeCloseDoorValveActive(
      Circuit_pressurized_p,
      Close_EV_p,
      Close_EV,
      CurrentTime,
      DeadlineStimulationOpenCloseEv,
      Close_EV_p_,
      DeadlineStimulationOpenCloseEv_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(timedAspects_MakeCloseDoorValveNoActive_inv4).
timedAspects_MakeCloseDoorValveNoActive_inv4 :-
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,
       DeadlineStimulationOpenCloseEv_],int) &
  dec([Close_EV_p,Close_EV,Close_EV_p_],bool) &
  dec(DeadlineUnlockLockDoorsCylinders_,rpi) &
  neg(
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_MakeCloseDoorValveNoActive(
      Close_EV_p,
      Close_EV,
      CurrentTime,
      DeadlineStimulationOpenCloseEv,
      Close_EV_p_,
      DeadlineStimulationOpenCloseEv_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(timedAspects_MakeExtendGearValveActive_inv6).
timedAspects_MakeExtendGearValveActive_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_],rpi) &
  dec([Extend_EV_p,Extend_EV,Circuit_pressurized_p,Extend_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_MakeExtendGearValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Extend_EV_p,
      Extend_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Extend_EV_p_,
      DeadlineStimulationRetExtEv_,
      DeadlineUnlockLockGearsCylinders_
     )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(n_timedAspects_inv8(int)).
n_timedAspects_inv8(DeadlineStimulationRetExtEv) :-
  neg(0 =< DeadlineStimulationRetExtEv).

:- dec_p_type(timedAspects_MakeExtendGearValveActive_inv8).
timedAspects_MakeExtendGearValveActive_inv8 :-
  dec(PositionsDG,sp) &
  dec(DeadlineUnlockLockGearsCylinders_,rpi) &
  dec([Extend_EV_p,Extend_EV,Circuit_pressurized_p,Extend_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv8(DeadlineStimulationRetExtEv) &
    timedAspects_MakeExtendGearValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Extend_EV_p,
      Extend_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Extend_EV_p_,
      DeadlineStimulationRetExtEv_,
      DeadlineUnlockLockGearsCylinders_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(timedAspects_MakeExtendGearValveNoActive_inv8).
timedAspects_MakeExtendGearValveNoActive_inv8 :-
  dec([Extend_EV_p,Extend_EV,Extend_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv8(DeadlineStimulationRetExtEv) &
    timedAspects_MakeExtendGearValveNoActive(
      Extend_EV_p,
      Extend_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Extend_EV_p_,
      DeadlineStimulationRetExtEv_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(timedAspects_MakeRetractGearValveActive_inv6).
timedAspects_MakeRetractGearValveActive_inv6 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders,DeadlineUnlockLockGearsCylinders_],rpi) &
  dec([Retract_EV_p,Retract_EV,Circuit_pressurized_p,Retract_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    timedAspects_MakeRetractGearValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Retract_EV_p,
      Retract_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Retract_EV_p_,
      DeadlineStimulationRetExtEv_,
      DeadlineUnlockLockGearsCylinders_
     )
      implies
        timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders_)
  ).

:- dec_p_type(timedAspects_MakeRetractGearValveActive_inv8).
timedAspects_MakeRetractGearValveActive_inv8 :-
  dec(PositionsDG,sp) &
  dec([DeadlineUnlockLockGearsCylinders_],rpi) &
  dec([Retract_EV_p,Retract_EV,Circuit_pressurized_p,Retract_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv8(DeadlineStimulationRetExtEv_) &
    timedAspects_MakeRetractGearValveActive(
      PositionsDG,
      Circuit_pressurized_p,
      Retract_EV_p,
      Retract_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Retract_EV_p_,
      DeadlineStimulationRetExtEv_,
      DeadlineUnlockLockGearsCylinders_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(timedAspects_MakeRetractGearValveNoActive_inv8).
timedAspects_MakeRetractGearValveNoActive_inv8 :-
  dec([Retract_EV_p,Retract_EV,Retract_EV_p_],bool) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,
       DeadlineStimulationRetExtEv_],int) &
  neg(
    timedAspects_inv8(DeadlineStimulationRetExtEv_) &
    timedAspects_MakeRetractGearValveNoActive(
      Retract_EV_p,
      Retract_EV,
      CurrentTime,
      DeadlineStimulationRetExtEv,
      Retract_EV_p_,
      DeadlineStimulationRetExtEv_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(n_timedAspects_inv2(int)).
n_timedAspects_inv2(DeadlineSwitch) :-
  neg(0 =< DeadlineSwitch).

:- dec_p_type(timedAspects_close_Switch_inv2).
timedAspects_close_Switch_inv2 :-
  dec([Intermediate1,Intermediate1_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  dec(Analogical_switch_p_,poss) &
  neg(
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_close_Switch(
      Intermediate1,
      CurrentTime,
      DeadlineSwitch,
      Analogical_switch_p_,
      Intermediate1_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).

:- dec_p_type(timedAspects_HandleOnClosed_inv2).
timedAspects_HandleOnClosed_inv2 :-
  dec([Handle,Handle_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  dec(Analogical_switch_p,poss) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_HandleOnClosed(
      Analogical_switch_p,
      Handle,
      CurrentTime,
      Handle_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).

:- dec_p_type(timedAspects_FromCloseToIntermediate2_inv2).
timedAspects_FromCloseToIntermediate2_inv2 :-
  dec([Intermediate2_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  dec([Analogical_switch_p,Analogical_switch_p_],poss) &
  neg(
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_FromCloseToIntermediate2(
      Analogical_switch_p,
      CurrentTime,
      DeadlineSwitch,
      Analogical_switch_p_,
      Intermediate2_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).

:- dec_p_type(timedAspects_HandleFromOpenToIntermediate1_inv2).
timedAspects_HandleFromOpenToIntermediate1_inv2 :-
  dec([Intermediate1,Intermediate2,Handle,Intermediate1_,Handle_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  dec(Analogical_switch_p,poss) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_HandleFromOpenToIntermediate1(
      Analogical_switch_p,
      Intermediate1,
      Intermediate2,
      Handle,
      CurrentTime,
      Intermediate1_,
      Handle_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).

% not proved in Rodin -- not provable
/*
int_solver(clpfd).
dec([Intermediate2,Handle,Intermediate1_,Intermediate2_,Handle_],bool) &
dec([DeadlineSwitch,DeadlineSwitch_],int) &
dec(Analogical_switch_p,poss) &
DeadlineSwitch in int(0,100) &
DeadlineSwitch_ < 0 & 
timedAspects_HandleFromIntermediate2ToIntermediate1(
  Intermediate2,
  Handle,
  0,                 % CurrentTime
  DeadlineSwitch,
  Intermediate1_,
  Intermediate2_,
  Handle_,
  DeadlineSwitch_
).
*/
:- dec_p_type(timedAspects_HandleFromIntermediate2ToIntermediate1_inv2).
timedAspects_HandleFromIntermediate2ToIntermediate1_inv2 :-
  dec([Intermediate2,Handle,Intermediate1_,Intermediate2_,Handle_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  dec(Analogical_switch_p,poss) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_HandleFromIntermediate2ToIntermediate1(
      Intermediate2,
      Handle,
      CurrentTime,
      DeadlineSwitch,
      Intermediate1_,
      Intermediate2_,
      Handle_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).

:- dec_p_type(timedAspects_HandleFromIntermediate2ToIntermediate1_act4).
timedAspects_HandleFromIntermediate2ToIntermediate1_act4 :-
  neg(3 neq 0).

:- dec_p_type(timedAspects_open_Switch_inv2).
timedAspects_open_Switch_inv2 :-
  dec([Intermediate2,Intermediate2_],bool) &
  dec([CurrentTime,DeadlineSwitch,DeadlineSwitch_],int) &
  neg(
    timedAspects_inv2(DeadlineSwitch) &
    timedAspects_open_Switch(
      Intermediate2,
      Intermediate2_,
      DeadlineSwitch_
     )
      implies
        timedAspects_inv2(DeadlineSwitch_)
  ).


:- dec_p_type(timedAspects_OutputGEV_inv3).
timedAspects_OutputGEV_inv3 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,DeadlineStimulationGeneralEv,AllowedStopGeneralEv,
       AllowedStartOpenEv,DeadlineStimulationGeneralEv_,
       AllowedStartOpenEv_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_],bool) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv3(DeadlineStimulationGeneralEv) &
    timedAspects_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_
     )
      implies
        timedAspects_inv3(DeadlineStimulationGeneralEv_)
  ).

:- dec_p_type(n_timedAspects_inv11(int)).
n_timedAspects_inv11(AllowedStartOpenEv) :-
  neg(0 =< AllowedStartOpenEv).

:- dec_p_type(timedAspects_OutputGEV_inv11).
timedAspects_OutputGEV_inv11 :-
  dec(PositionsDG,sp) &
  dec(Analogical_switch_ind,poss) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Gear_retracted_ind,Door_closed_ind],rpb) &
  dec([CurrentTime,AllowedStopGeneralEv,AllowedStartOpenEv,
       DeadlineStimulationGeneralEv_,AllowedStartOpenEv_],int) &
  dec([Open_EV,Close_EV,General_EV,General_EV_,End_cycle_],bool) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv11(AllowedStartOpenEv) &
    timedAspects_OutputGEV(
      PositionsDG,
      Analogical_switch_ind,
      Handle_ind,
      Gear_extended_ind,
      Gear_retracted_ind,
      Open_EV,
      Close_EV,
      General_EV,
      CurrentTime,
      AllowedStopGeneralEv,
      AllowedStartOpenEv,
      Door_closed_ind,
      General_EV_,
      End_cycle_,
      DeadlineStimulationGeneralEv_,
      AllowedStartOpenEv_
     )
      implies
        timedAspects_inv11(AllowedStartOpenEv_)
  ).

:- dec_p_type(timedAspects_OutputGEV_act3).
timedAspects_OutputGEV_act3 :-
  dec([General_EV,General_EV_value],bool) &
  dec([CurrentTime,M1,M2],int) &
  neg(
    General_EV_value neq General_EV &
    M1 is CurrentTime + 10 &
    M2 is CurrentTime + 36
      implies
        ncomp(
          {[[General_EV,General_EV_value],[General_EV,General_EV_value]]},
          {[[false,true],M1],[[true,false],M2]},
          {}
        ) &
        pfun({[[false,true],M1],[[true,false],M2]})
      ).

:- dec_p_type(timedAspects_OutputGEV_act4).
timedAspects_OutputGEV_act4 :-
  dec([General_EV,General_EV_value],bool) &
  dec([CurrentTime,M3,AllowedStartOpenEv],int) &
  neg(
    General_EV_value neq General_EV &
    M3 is CurrentTime + 2
      implies
        ncomp(
          {[[General_EV,General_EV_value],[General_EV,General_EV_value]]},
          {[[false,true],M3],[[true,false],AllowedStartOpenEv]},
          {}
        ) &
        pfun({[[false,true],M3],[[true,false],AllowedStartOpenEv]})
      ).

:- dec_p_type(timedAspects_OutputOpenEV_inv4).
timedAspects_OutputOpenEV_inv4 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(n_timedAspects_inv10(int)).
n_timedAspects_inv10(AllowedStopGeneralEv) :-
  neg(0 =< AllowedStopGeneralEv).

:- dec_p_type(timedAspects_OutputOpenEV_inv10).
timedAspects_OutputOpenEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,AllowedStartCloseEv,AllowedStopGeneralEv,
       AllowedStartCloseEv_,DeadlineStimulationOpenCloseEv_,
       AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv10(AllowedStopGeneralEv) &
    timedAspects_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv10(AllowedStopGeneralEv_)
  ).

:- dec_p_type(n_timedAspects_inv12(int)).
n_timedAspects_inv12(AllowedStartCloseEv) :-
  neg(0 =< AllowedStartCloseEv).

:- dec_p_type(timedAspects_OutputOpenEV_inv12).
timedAspects_OutputOpenEV_inv12 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,AllowedStartCloseEv,AllowedStopGeneralEv,
       AllowedStartCloseEv_,DeadlineStimulationOpenCloseEv_,
       AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Circuit_pressurized_p,Open_EV,
       Retract_EV,Open_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv12(AllowedStartCloseEv) &
    timedAspects_OutputOpenEV(
      PositionsDG,
      Close_EV,
      Open_EV,
      General_EV,
      Extend_EV,
      Retract_EV,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Open_EV_,
      End_cycle_,
      AllowedStartCloseEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv12(AllowedStartCloseEv_)
  ).


:- dec_p_type(timedAspects_OutputOpenEV_act3).
timedAspects_OutputOpenEV_act3 :-
  dec([Open_EV,Open_EV_value],bool) &
  dec([CurrentTime,M1,AllowedStartCloseEv],int) &
  neg(
    Open_EV_value neq Open_EV &
    M1 is CurrentTime + 2
      implies
        ncomp(
          {[[Open_EV,Open_EV_value],[Open_EV,Open_EV_value]]},
          {[[false,true],M1],[[true,false],AllowedStartCloseEv]},
          {}
        ) &
        pfun({[[false,true],M1],[[true,false],AllowedStartCloseEv]})
      ).

:- dec_p_type(timedAspects_OutputOpenEV_act4).
timedAspects_OutputOpenEV_act4 :-
  dec([Open_EV,Open_EV_value],bool) &
  dec([CurrentTime,M2,M3],int) &
  neg(
    Open_EV_value neq Open_EV &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36
      implies
        ncomp(
          {[[Open_EV,Open_EV_value],[Open_EV,Open_EV_value]]},
          {[[false,true],M2],[[true,false],M3]},
          {}
        ) &
        pfun({[[false,true],M2],[[true,false],M3]})
      ).

:- dec_p_type(timedAspects_OutputOpenEV_act5).
timedAspects_OutputOpenEV_act5 :-
  dec([Open_EV,Open_EV_value],bool) &
  dec([CurrentTime,M2,M3,AllowedStopGeneralEv],int) &
  neg(
    Open_EV_value neq Open_EV &
    M2 is CurrentTime + 10
      implies
        ncomp(
          {[[Open_EV,Open_EV_value],[Open_EV,Open_EV_value]]},
          {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
          {}
        ) &
        pfun({[[false,true],AllowedStopGeneralEv],[[true,false],M2]})
      ).

:- dec_p_type(timedAspects_OutputCloseEv_inv4).
timedAspects_OutputCloseEv_inv4 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationOpenCloseEv,AllowedStartOpenEv,
      AllowedStartCloseEv,AllowedStopGeneralEv,AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv4(DeadlineStimulationOpenCloseEv) &
    timedAspects_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv4(DeadlineStimulationOpenCloseEv_)
  ).

:- dec_p_type(timedAspects_OutputCloseEv_inv10).
timedAspects_OutputCloseEv_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,AllowedStartCloseEv,AllowedStopGeneralEv,
       AllowedStartOpenEv_,DeadlineStimulationOpenCloseEv_,
       AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv10(AllowedStopGeneralEv) &
    timedAspects_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv10(AllowedStopGeneralEv_)
  ).

:- dec_p_type(timedAspects_OutputCloseEv_inv11).
timedAspects_OutputCloseEv_inv11 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartOpenEv,AllowedStartCloseEv,AllowedStopGeneralEv,
       AllowedStartOpenEv_,DeadlineStimulationOpenCloseEv_,
       AllowedStopGeneralEv_],int) &
  dec([Close_EV,General_EV,Extend_EV,Open_EV,Retract_EV,Close_EV_,
       End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Gear_extended_ind,Door_closed_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv11(AllowedStartOpenEv) &
    timedAspects_OutputCloseEv(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Gear_extended_ind,
      Door_closed_ind,
      General_EV,
      Extend_EV,
      Retract_EV,
      Open_EV,
      Close_EV,
      CurrentTime,
      AllowedStartOpenEv,
      AllowedStartCloseEv,
      AllowedStopGeneralEv,
      Close_EV_,
      End_cycle_,
      AllowedStartOpenEv_,
      DeadlineStimulationOpenCloseEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv11(AllowedStartOpenEv_)
  ).

:- dec_p_type(timedAspects_OutputCloseEv_act3).
timedAspects_OutputCloseEv_act3 :-
  dec([Close_EV,Close_EV_value],bool) &
  dec([CurrentTime,M2,M3],int) &
  neg(
    Close_EV neq Close_EV_value &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36
      implies
        ncomp(
          {[[Close_EV,Close_EV_value],[Close_EV,Close_EV_value]]},
          {[[false,true],M2],[[true,false],M3]},
          {}
        ) &
        pfun({[[false,true],M2],[[true,false],M3]})
      ).

:- dec_p_type(timedAspects_OutputCloseEv_act4).
timedAspects_OutputCloseEv_act4 :-
  dec([Close_EV,Close_EV_value],bool) &
  dec([CurrentTime,M1,AllowedStartOpenEv],int) &
  neg(
    Close_EV neq Close_EV_value &
    M1 is CurrentTime + 2
      implies
        ncomp(
          {[[Close_EV,Close_EV_value],[Close_EV,Close_EV_value]]},
          {[[false,true],M1],[[true,false],AllowedStartOpenEv]},
          {}
        ) &
        pfun({[[false,true],M1],[[true,false],AllowedStartOpenEv]})
      ).

:- dec_p_type(timedAspects_OutputCloseEv_act5).
timedAspects_OutputCloseEv_act5 :-
  dec([Close_EV,Close_EV_value],bool) &
  dec([CurrentTime,M2,AllowedStopGeneralEv],int) &
  neg(
    Close_EV neq Close_EV_value &
    M2 is CurrentTime + 10
      implies
        ncomp(
          {[[Close_EV,Close_EV_value],[Close_EV,Close_EV_value]]},
          {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
          {}
        ) &
        pfun({[[false,true],AllowedStopGeneralEv],[[true,false],M2]})
      ).

:- dec_p_type(timedAspects_OutputExtendEV_inv8).
timedAspects_OutputExtendEV_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,AllowedStartExtEv,
       AllowedStartRetEv,AllowedStopGeneralEv,DeadlineStimulationRetExtEv_,
       AllowedStartRetEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv8(DeadlineStimulationRetExtEv) &
    timedAspects_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(timedAspects_OutputExtendEV_inv10).
timedAspects_OutputExtendEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv10(AllowedStopGeneralEv) &
    timedAspects_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv10(AllowedStopGeneralEv_)
  ).

:- dec_p_type(n_timedAspects_inv14(int)).
n_timedAspects_inv14(AllowedStartRetEv) :-
  neg(0 =< AllowedStartRetEv).

:- dec_p_type(timedAspects_OutputExtendEV_inv14).
timedAspects_OutputExtendEV_inv14 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartRetEv_,
       AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Extend_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_extended_ind,Door_open_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv14(AllowedStartRetEv) &
    timedAspects_OutputExtendEV(
      PositionsDG,
      Handle_ind,
      Gear_extended_ind,
      Door_open_ind,
      Open_EV,
      Retract_EV,
      Extend_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Extend_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartRetEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv14(AllowedStartRetEv_)
  ).

:- dec_p_type(timedAspects_OutputExtendedEV_act3).
timedAspects_OutputExtendedEV_act3 :-
  dec([Extend_EV,Extend_EV_value],bool) &
  dec([CurrentTime,M2,M3],int) &
  neg(
    Extend_EV neq Extend_EV_value &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36
      implies
        ncomp(
          {[[Extend_EV,Extend_EV_value],[Extend_EV,Extend_EV_value]]},
          {[[false,true],M2],[[true,false],M3]},
          {}
        ) &
        pfun({[[false,true],M2],[[true,false],M3]})
      ).

:- dec_p_type(timedAspects_OutputExtendedEV_act4).
timedAspects_OutputExtendedEV_act4 :-
  dec([Extend_EV,Extend_EV_value],bool) &
  dec([CurrentTime,M1,AllowedStartRetEv],int) &
  neg(
    Extend_EV neq Extend_EV_value &
    M1 is CurrentTime + 2
      implies
        ncomp(
          {[[Extend_EV,Extend_EV_value],[Extend_EV,Extend_EV_value]]},
          {[[false,true],M1],[[true,false],AllowedStartRetEv]},
          {}
        ) &
        pfun({[[false,true],M1],[[true,false],AllowedStartRetEv]})
      ).

:- dec_p_type(timedAspects_OutputExtendedEV_act5).
timedAspects_OutputExtendedEV_act5 :-
  dec([Extend_EV,Extend_EV_value],bool) &
  dec([CurrentTime,M2,AllowedStopGeneralEv],int) &
  neg(
    Extend_EV neq Extend_EV_value &
    M2 is CurrentTime + 10
      implies
        ncomp(
          {[[Extend_EV,Extend_EV_value],[Extend_EV,Extend_EV_value]]},
          {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
          {}
        ) &
        pfun({[[false,true],AllowedStopGeneralEv],[[true,false],M2]})
      ).

:- dec_p_type(timedAspects_OutputRetractEV_inv8).
timedAspects_OutputRetractEV_inv8 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,DeadlineStimulationRetExtEv,AllowedStartExtEv,
       AllowedStartRetEv,AllowedStopGeneralEv,DeadlineStimulationRetExtEv_,
       AllowedStartExtEv_,AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv8(DeadlineStimulationRetExtEv) &
    timedAspects_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv8(DeadlineStimulationRetExtEv_)
  ).

:- dec_p_type(timedAspects_OutputRetractEV_inv10).
timedAspects_OutputRetractEV_inv10 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartExtEv_,
       AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv10(AllowedStopGeneralEv) &
    timedAspects_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv10(AllowedStopGeneralEv_)
  ).

:- dec_p_type(n_timedAspects_inv13(int)).
n_timedAspects_inv13(AllowedStartExtEv) :-
  neg(0 =< AllowedStartExtEv).

:- dec_p_type(timedAspects_OutputRetractEV_inv13).
timedAspects_OutputRetractEV_inv13 :-
  dec(PositionsDG,sp) &
  dec([CurrentTime,AllowedStartExtEv,AllowedStartRetEv,AllowedStopGeneralEv,
       DeadlineStimulationRetExtEv_,AllowedStartExtEv_,
       AllowedStopGeneralEv_],int) &
  dec([Extend_EV,Open_EV,Retract_EV,Retract_EV_,End_cycle_],bool) &
  dec(Handle_ind,posh) &
  dec([Gear_retracted_ind,Door_open_ind,Gear_shock_absorber_ind],rpb) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_inv13(AllowedStartExtEv) &
    timedAspects_OutputRetractEV(
      PositionsDG,
      Handle_ind,
      Gear_retracted_ind,
      Door_open_ind,
      Gear_shock_absorber_ind,
      Open_EV,
      Extend_EV,
      Retract_EV,
      CurrentTime,
      AllowedStartExtEv,
      AllowedStartRetEv,
      AllowedStopGeneralEv,
      Retract_EV_,
      End_cycle_,
      DeadlineStimulationRetExtEv_,
      AllowedStartExtEv_,
      AllowedStopGeneralEv_
     )
      implies
        timedAspects_inv13(AllowedStartExtEv_)
  ).

:- dec_p_type(timedAspects_OutputRetractEV_act3).
timedAspects_OutputRetractEV_act3 :-
  dec([Retract_EV,Retract_EV_value],bool) &
  dec([CurrentTime,M2,M3],int) &
  neg(
    Retract_EV neq Retract_EV_value &
    M2 is CurrentTime + 10 &
    M3 is CurrentTime + 36
      implies
        ncomp(
          {[[Retract_EV,Retract_EV_value],[Retract_EV,Retract_EV_value]]},
          {[[false,true],M2],[[true,false],M3]},
          {}
        ) &
        pfun({[[false,true],M2],[[true,false],M3]})
      ).

:- dec_p_type(timedAspects_OutputRetractEV_act4).
timedAspects_OutputRetractEV_act4 :-
  dec([Retract_EV,Retract_EV_value],bool) &
  dec([CurrentTime,M1,AllowedStartExtEv],int) &
  neg(
    Retract_EV neq Retract_EV_value &
    M1 is CurrentTime + 2
      implies
        ncomp(
          {[[Retract_EV,Retract_EV_value],[Retract_EV,Retract_EV_value]]},
          {[[false,true],M1],[[true,false],AllowedStartExtEv]},
          {}
        ) &
        pfun({[[false,true],M1],[[true,false],AllowedStartExtEv]})
      ).

:- dec_p_type(timedAspects_OutputRetractEV_act5).
timedAspects_OutputRetractEV_act5 :-
  dec([Retract_EV,Retract_EV_value],bool) &
  dec([CurrentTime,M2,AllowedStopGeneralEv],int) &
  neg(
    Retract_EV neq Retract_EV_value &
    M2 is CurrentTime + 10
      implies
        ncomp(
          {[[Retract_EV,Retract_EV_value],[Retract_EV,Retract_EV_value]]},
          {[[false,true],AllowedStopGeneralEv],[[true,false],M2]},
          {}
        ) &
        pfun({[[false,true],AllowedStopGeneralEv],[[true,false],M2]})
      ).

% REQ instead of UEQ
:- dec_p_type(timedAspects_passingTime_grd7).
timedAspects_passingTime_grd7 :-
  dec([DeadlineOpenCloseDoors,M1],rpi) &
  dec(M2,stype(int)) &
  dec(PositionsDG,sp) &
  neg(
    PositionsDG = {front,left,right} &   % otherwise undecidable problem
    timedAspects_inv7(PositionsDG,DeadlineOpenCloseDoors) &
    rares(DeadlineOpenCloseDoors,{0},M1) &
    ran(M1,M2) &
    nran(DeadlineOpenCloseDoors,{0})
      implies
        M2 neq {} &
        exists(B in M2,
          dec(B,int) &
          foreach(X in M2,dec(X,int) & B =< X)
        )
  ).

% REQ instead of UEQ
:- dec_p_type(timedAspects_passingTime_grd8).
timedAspects_passingTime_grd8 :-
  dec([DeadlineUnlockLockDoorsCylinders,M1],rpi) &
  dec(M2,stype(int)) &
  dec(PositionsDG,sp) &
  neg(
    PositionsDG = {front,left,right} &   % otherwise undecidable problem
    timedAspects_inv5(PositionsDG,DeadlineUnlockLockDoorsCylinders) &
    rares(DeadlineUnlockLockDoorsCylinders,{0},M1) &
    ran(M1,M2) &
    nran(DeadlineUnlockLockDoorsCylinders,{0})
      implies
        M2 neq {} &
        exists(B in M2,
          dec(B,int) &
          foreach(X in M2,dec(X,int) & B =< X)
        )
  ).

% REQ instead of UEQ
:- dec_p_type(timedAspects_passingTime_grd9).
timedAspects_passingTime_grd9 :-
  dec([DeadlineUnlockLockGearsCylinders,M1],rpi) &
  dec(M2,stype(int)) &
  dec(PositionsDG,sp) &
  neg(
    PositionsDG = {front,left,right} &   % otherwise undecidable problem
    timedAspects_inv6(PositionsDG,DeadlineUnlockLockGearsCylinders) &
    rares(DeadlineUnlockLockGearsCylinders,{0},M1) &
    ran(M1,M2) &
    nran(DeadlineUnlockLockGearsCylinders,{0})
      implies
        M2 neq {} &
        exists(B in M2,
          dec(B,int) &
          foreach(X in M2,dec(X,int) & B =< X)
        )
  ).

% REQ instead of UEQ
:- dec_p_type(timedAspects_passingTime_grd10).
timedAspects_passingTime_grd10 :-
  dec([DeadlineGearsRetractingExtending,M1],rpi) &
  dec(M2,stype(int)) &
  dec(PositionsDG,sp) &
  neg(
    PositionsDG = {front,left,right} &   % otherwise undecidable problem
    timedAspects_inv9(PositionsDG,DeadlineGearsRetractingExtending) &
    rares(DeadlineGearsRetractingExtending,{0},M1) &
    ran(M1,M2) &
    nran(DeadlineGearsRetractingExtending,{0})
      implies
        M2 neq {} &
        exists(B in M2,
          dec(B,int) &
          foreach(X in M2,dec(X,int) & B =< X)
        )
  ).

:- dec_p_type(n_timedAspects_inv1(int)).
n_timedAspects_inv1(CurrentTime) :-
  neg(0 =< CurrentTime).

:- dec_p_type(timedAspects_passingTime_inv1).
timedAspects_passingTime_inv1 :-
  dec([DeadlineSwitch,DeadlineStimulationGeneralEv,CurrentTime,CurrentTime_,
       DeadlineStimulationOpenCloseEv,DeadlineStimulationRetExtEv],int) &
  dec([DeadlineOpenCloseDoors,DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,DeadlineGearsRetractingExtending],rpi) &
  neg(
    timedAspects_inv1(CurrentTime) &
    timedAspects_passingTime(
      DeadlineSwitch,
      DeadlineStimulationGeneralEv,
      DeadlineStimulationOpenCloseEv,
      DeadlineStimulationRetExtEv,
      DeadlineOpenCloseDoors,
      DeadlineUnlockLockDoorsCylinders,
      DeadlineUnlockLockGearsCylinders,
      DeadlineGearsRetractingExtending,
      CurrentTime,
      CurrentTime_    
    )
      implies
        timedAspects_inv1(CurrentTime_)
  ).


% consult('lgs.pl') & lTimedAspectsPO.
:- dec_p_type(check_timedAspects).
check_timedAspects :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking timedAspects_init_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv1 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv2 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv3 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv4 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv5 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv6 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv7 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv8 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv9 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv10 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv11 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv12 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv13 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_init_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     timedAspects_init_inv14 &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearExtend_grd8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearExtend_grd8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearExtend_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearExtend_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearExtend_act2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearExtend_act2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_GearExtended_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_GearExtended_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_GearExtended_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_GearExtended_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_GearExtended_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_GearExtended_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearRetract_grd8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearRetract_grd8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearRetract_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearRetract_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearRetract_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearRetract_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearRetract_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearRetract_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_GearRetract_grd8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_GearRetract_grd8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_GearRetracted_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_GearRetracted_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_GearRetracted_inv9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_GearRetracted_inv9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorOpening_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorOpening_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorOpening_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorOpening_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorOpening_act2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorOpening_act2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_DoorOpen_grd9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_DoorOpen_grd9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorOpening_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorOpening_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorClosing_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorClosing_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_start_DoorClosing_act2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_start_DoorClosing_act2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_DoorClosed_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_DoorClosed_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_DoorClosed_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_DoorClosed_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_make_DoorClosed_inv7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_make_DoorClosed_inv7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_LockGearCylinder_grd6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_LockGearCylinder_grd6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_LockGearCylinder_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_LockGearCylinder_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_UnlockDoorCylinder_grd7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_UnlockDoorCylinder_grd7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_UnlockDoorCylinder_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_UnlockDoorCylinder_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_LockDoorCylinder_grd7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_LockDoorCylinder_grd7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_LockDoorCylinder_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_LockDoorCylinder_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_UnlockGearCylinder_grd7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_UnlockGearCylinder_grd7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_UnlockGearCylinder_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_UnlockGearCylinder_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeGeneralValveActive_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeGeneralValveActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeGeneralValveNoActive_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeGeneralValveNoActive_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeOpenDoorValveActive_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeOpenDoorValveActive_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeOpenDoorValveActive_inv5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeOpenDoorValveActive_inv5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeOpenDoorValveNoActive_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeOpenDoorValveNoActive_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeCloseDoorValveActive_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeCloseDoorValveActive_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeCloseDoorValveNoActive_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeCloseDoorValveNoActive_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeExtendGearValveActive_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeExtendGearValveActive_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeExtendGearValveActive_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeExtendGearValveActive_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeExtendGearValveNoActive_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeExtendGearValveNoActive_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeRetractGearValveActive_inv6...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeRetractGearValveActive_inv6) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeRetractGearValveActive_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeRetractGearValveActive_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_MakeRetractGearValveNoActive_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_MakeRetractGearValveNoActive_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_close_Switch_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_close_Switch_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_HandleOnClosed_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_HandleOnClosed_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_FromCloseToIntermediate2_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_FromCloseToIntermediate2_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_HandleFromOpenToIntermediate1_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_HandleFromOpenToIntermediate1_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('timedAspects_HandleFromIntermediate2ToIntermediate1_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_HandleFromIntermediate2ToIntermediate1_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & 
     write('Checking ') &
     write('timedAspects_HandleFromIntermediate2ToIntermediate1_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_HandleFromIntermediate2ToIntermediate1_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_open_Switch_inv2...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_open_Switch_inv2) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputGEV_inv3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputGEV_inv3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputGEV_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputGEV_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputGEV_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputGEV_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputGEV_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputGEV_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_inv12...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_inv12) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputOpenEV_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputOpenEV_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_inv4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_inv4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_inv11...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_inv11) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputCloseEv_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputCloseEv_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendEV_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendEV_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendEV_inv14...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendEV_inv14) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendedEV_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendedEV_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendedEV_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendedEV_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputExtendedEV_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputExtendedEV_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_inv8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_inv8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_inv10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_inv10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_inv13...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_inv13) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_act3...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_act3) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_act4...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_act4) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_OutputRetractEV_act5...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_OutputRetractEV_act5) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_passingTime_grd7...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_passingTime_grd7) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_passingTime_grd8...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_passingTime_grd8) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_passingTime_grd9...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_passingTime_grd9) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_passingTime_grd10...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_passingTime_grd10) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking timedAspects_passingTime_inv1...') &
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(timedAspects_passingTime_inv1) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 98) discharged in ') &
     write(T) & write(' seconds') & nl
  ).










